// PART 1: AUDIO
datablock AudioProfile(HealthLockerOpenSound)
{
	filename = "./lockeropen.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(HealthLockerCloseSound)
{
	filename = "./lockerclose.wav";
	description = AudioClosest3d;
	preload = true;
};

// PART 2: PROP
datablock ItemData(healthLockerItem)
{
	category = "Item";
	shapeFile = "./HealthLocker15.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "";
	iconName = "./ItemIcons/RMedKit";
	doColorShift = false;
	image = "";
	canDrop = true;
};
function healthLockerItem::onPickup(%this,%obj,%pl)
{
   if(%pl.getState() $= Dead)
      return;
   if(%obj.spawnbrick.lockerTeam !$= %pl.client.bb_team)
      return;
   if(%pl.getDamageLevel() > 0 || (%pl.client.bb_screws < 200 && %pl.client.bb_class $= BB_CLASS_ENGINEER))
      %pl.emote(HealImage);
      %pl.setDamageLevel(0);
   if(%pl.client.bb_class $= BB_CLASS_ENGINEER)
      %pl.client.bb_screws = 200;
   if(%pl.isOnFire)
   {
      %pl.isOnFire = 0;
      %pl.clearBurn();
   }
   healthLockerAnimation(%obj);
}

// PART 3: COMMON BRICK
datablock fxDTSBrickData (brickCommonLockerData)
{
	brickFile = "./LockerBrick.blb";
	category = "Special";
	subCategory = "Block Bastion";
	uiName = "";
	iconName = $BB::Path @ "bricks/Icons/Icon_HealthLocker";
	indestructable = 1;
};

// PART 4: RED
datablock fxDTSBrickData (brickREDHealthData : brickCommonLockerData)
{
   uiName = "RED Health Locker";
};
function brickREDHealthData::onPlant(%data, %brick)
{
   %brick.lockerTeam = BB_TEAM_RED;
   %brick.setRendering(0);
   %attach = new Item()
   {
      datablock = "healthLockerItem";
      static = 1;
   };
   %attach.spawnbrick = %brick;
   %attach.settransform(vectoradd(%brick.gettransform(),"0 0 -1.42") SPC getwords(%brick.gettransform(),3,6));
   %brick.attachment = %attach;
   parent::onPlant(%data, %brick);
}
function brickREDHealthData::onRemove(%data, %brick)
{
   if(isObject(%brick.attachment))
      %brick.attachment.delete();
}

// PART 5: BLU
datablock fxDTSBrickData (brickBLUHealthData : brickCommonLockerData)
{
   uiName = "BLU Health Locker";
};
function brickBLUHealthData::onPlant(%data, %brick)
{
   %brick.lockerTeam = BB_TEAM_BLU;
   %brick.setRendering(0);
   %attach = new Item()
   {
      datablock = "healthLockerItem";
      static = 1;
   };
   %attach.spawnbrick = %brick;
   %attach.settransform(vectoradd(%brick.gettransform(),"0 0 -1.42") SPC getwords(%brick.gettransform(),3,6));
   %brick.attachment = %attach;
   parent::onPlant(%data, %brick);
}
function brickBLUHealthData::onRemove(%data, %brick)
{
   if(isObject(%brick.attachment))
      %brick.attachment.delete();
}

// PART 6: LOCKER ANIMATION
function healthLockerAnimation(%this)
{
   if(%this.isOpening)
      return;
   if(%this.isClosing)
      return;
   %this.playAudio(2,HealthLockerOpenSound);
   %this.playThread(1,open);
   %this.isOpening = true;
   schedule(600,0,healthLockerAnimation2,%this);
}
function healthLockerAnimation2(%this)
{
   if(!%this.isOpening)
      return;
   if(%this.isClosing)
      return;
   %this.playAudio(2,HealthLockerCloseSound);
   %this.playThread(1,close);
   %this.isClosing = true;
   %this.isOpening = false;
   schedule(600,0,healthLockerAnimation3,%this);
}
function healthLockerAnimation3(%this)
{
   if(%this.isOpening)
      return;
   if(!%this.isClosing)
      return;
   %this.isClosing = false;
}