function registerAchievement(%name, %type, %amnt)
{
   if(!isObject(bb_achievementGroup)) new ScriptGroup(bb_achievementGroup);
   switch$ (%type)
   {
      case "unlock":
      case "progress":
      default: return -1;
   }
   for(%i=0;%i<bb_achievementGroup.getCount();%i++)
   {
      if(bb_achievementGroup.getObject(%i).uiname $= %name)
         return -2;
   }
   %obj = new ScriptObject()
   {
      uiname = %name;
      type = %type;
      amnt = (%type$="progress" ? %amnt : -1);
   };
   bb_achievementGroup.add(%obj);
}

function getAchievementData(%client, %name)
{
   for(%i=0;%i<bb_achievementGroup.getCount();%i++)
   {
      if(bb_achievementGroup.getObject(%i).uiname $= %name)
      {
         %found = true;
         break;
      }
   }
   if(!%found)
      return -1;
   if(!isObject(%client))
      return -2;
   if(!isFile("config/server/blockbastion/achsaves/"@%client.bl_id@".dat"))
      return -3;
   %fo = new FileObject();
   %fo.openForRead("config/server/blockbastion/achsaves/"@%client.bl_id@".dat");
   while(!%fo.isEOF())
   {
      %line = %fo.readLine();
      if(strpos(%line,": ") < 1 || getSubStr(%line,0,strPos(%line,": ")) !$= %name)
         continue;
      %dat = getSubStr(%line,strPos(%line,": ")+2,strLen(%line));
   }
   %fo.close();
   %fo.delete();
   if(strLen(%dat) > 0)
      return %dat;
   else
      return -2;
}
function saveAchievementData(%cl) {
   %fo = new FileObject();
   %fo.openForWrite("config/server/blockbastion/achsaves/"@%cl.bl_id@".dat");
   for(%i=0;%i<bb_achievementGroup.getCount();%i++) {
      %achobj = bb_achievementGroup.getObject(%i);
      %fo.writeLine(%achobj.uiname @ ":" SPC %cl.achData[%achobj.uiName]);
   }
   return 1;
}
function loadAchievementData(%cl) {
   %cl.loadedAchData = true;
   %fo = new FileObject();
   %fo.openForRead("config/server/blockbastion/achsaves/"@%cl.bl_id@".dat");
   while(!%fo.isEOF()) {
      %line = %fo.readLine();
      if(strpos(%line,": ") < 1 || getSubStr(%line,0,strPos(%line,": ")) !$= %name)
         continue;
      %cl.achData[getSubStr(%line,0,strPos(%line,": "))] = getSubStr(%line,strPos(%line,": ")+2,strLen(%line)); 
	}
}

function clientAchProgress(%client, %name, %progress, %total)
{
   %name = StripMLControlChars(%name);
      
   if(%client.unLockedAchievements[%name])
      return;
   
   if(%client.achievementProgress[%name] $= %progress)
      return;
   
   %client.achievementProgress[%name] = %progress;
   
   %file = new FileObject();
   %file.openForAppend("config/Achievements/saves/"@%client.BL_ID@".prg");
   %file.writeLine(%name TAB %progress);
   %file.close();
   %file.delete();
   
   if(%progress >= %total)
      unlockClientAchievement(%client, %name);
   else
      messageClient(%client,'',"\c6Achievement Progress ("@%name@"): "@%progress@" out of "@%total@".");
}

function unlockClientAchievement(%client, %name)
{
   %name = StripMLControlChars(%name);
      
   if(%client.unLockedAchievements[%name])
      return;
   
   messageAll('',"\c3"@%client.name@" \c6has unlocked the achievement: \c2"@%name);
   %client.unLockedAchievements[%name] = true;
   
   %file = new FileObject();
   %file.openForAppend("config/Achievements/saves/"@%client.BL_ID@".txt");
   %file.writeLine(%name);
   %file.close();
   %file.delete();
}

function loadClientAchievements(%client)
{
   %file = new FileObject();
   %file.openForRead("config/Achievements/saves/"@%client.BL_ID@".txt");
   
   while(!%file.isEOF()) {
      %line = %file.readLine();
      if(%line !$= "") {
         %data['Name'] = getField(%line, 0);
         %client.unLockedAchievements[%data['Name']] = true;
      }
   }
   %file.close();
   %file.openForRead("config/Achievements/saves/"@%client.BL_ID@".prg");
   while(!%file.isEOF()) {
      %line = %file.readLine();
      if(%line !$= "") {
         %data['Name'] = getField(%line, 0);
         %data['Progress'] = getField(%line, 1);
         %client.achievementProgress[%data['Name']] = %data['Progress'];
      }
   }
   %file.close();
   %file.delete();
}

package AchClientEnterGame {
   function gameConnection::onClientEnterGame(%this)
	{
		parent::onClientEnterGame(%this);
      loadClientAchievements(%this);
	}
};
activatepackage(AchClientEnterGame);