datablock fxDTSBrickData(brickPFNodeData : brick2x2FData)
{
   category = "Special";
   subCategory = "Block Bastion";
   
   PF_isWalkable = 1;
   uiName = "BastionBot Node";
};

package onNodePlant
{
   function fxDTSBrick::onPlant(%this)
   {
      Parent::onPlant(%this);
      if(%this.getDatablock().getName()  $= brickPFNodeData)
      {
         %this.setRendering(0);
         %this.setColliding(0);
      }
   }
};
activatePackage(onNodePlant);

function AIPlayer::BB_moveToNode(%this,%node)
{
   return BB_beginPathfindMath(%this,%node);
}

function AIPlayer::finishPFPath(%this)
{
   switch$ (%this.type)
   {
      case "none": return;
      case "respawn": %this.instantRespawn();
   }
   %this.spawnBrick.onPFDone();
}
function BB_beginPathfindMath(%bot,%b2)
{
   if(!isObject(%bot) || !isObject(%b2))
      return "invalid_objects";
   %p1 = %bot.getPosition();
   %p2 = %b2.getPosition();
   %array = trim(AI_pathGetInstr(%p1,%p2));
   if(%array $= "failure")
      return "not_possible";
   if(!%array.contains(%b2))
      %array.addElement(%b2);
   %bot.goal = %b2;
   %bot.instructions = %array;
   %bot.index = 0;
   %bot.finalMove = false;
   %bot.dontRemove = true;
   %bot.ticktock();
   return "success";
}
function AIPlayer::ticktock(%this)
{
   cancel(%this.ticktock);
   %i = %this.index;
   %d = %this.instructions;
   if(%this.finalMove && isObject(%this.movingTo))
   {
      if(vectorDist(%this.getPosition(),%this.movingTo.getPosition()) <= 0.2)
      {
         %this.schedule(100,finishPFPath);
         %this.stop();
         %this.movingTo = 0;
         %this.index = 0;
         %this.instructions = 0;
         return;
      }
   }
   else if(%i < 0 || %i >= %d.getSize())
   {
      //if(%this.type !$= "return" && isObject(%this.goal))
      //{
      //   %this.finalMove = true;
      //   %this.movingTo = %this.goal;
      //   %this.setMoveDestination(%this.goal.getPosition(),false);
      //}
      if(true)
      {
         %this.schedule(100,finishPFPath);
         %this.stop();
         %this.movingTo = 0;
         %this.index = 0;
         %this.instructions = 0;
         return;
      }
   }
   else if(!isObject(%this.movingTo))
   {
      %instr = %d.getElement(%i);
      if($DEBUG)
         announce("Bot moving to next part ("@%i+1@"/"@%d.getSize()@"): "@%instr);
      if(isObject(%instr))
      {
         %this.movingTo = %instr;
         %this.setMoveDestination(%instr.getPosition(),false);
         %this.setAimLocation(%instr.getPosition());
      }
      %this.index++;
   }
   else if(vectorDist(%this.getPosition(),%this.movingTo.getPosition()) <= 1.3)
   {
      %this.stop();
      %this.movingTo = 0;
   }
   %this.ticktock = %this.schedule(100,ticktock);
}
function AI_pathGetInstr(%cl,%p1,%p2)
{
   %sep = BB_getSepL();
   for(%i=0;%i<getWordCount(%sep);%i++)
   {
      %o = getWord(%sep,%i);
      %d1 = vectorDist(%p1,%o.getPosition());
      %d2 = vectorDist(%p2,%o.getPosition());
      if(strLen(%cd1) < 1 || %d1 < %cd1)
      {
         %b1 = %o;
         %cd1 = %d1;
      }
      if(strLen(%cd2) < 1 || %d < %cd2)
      {
         %b2 = %o;
         %cd2 = %d2;
      }
   }
   return aStar(%sep,%b1,%b2);
}
function aStar(%sl,%start,%goal)
{
   while(isObject(closedset)) closedset.delete();
   while(isObject(openset)) openset.delete();
   while(isObject(camefrom)) camefrom.delete();
      
   new ScriptObject(camefrom) { class = "Array"; };
   new ScriptObject(closedset) { class = "Array"; };
   new ScriptObject(openset) { class = "Array"; }
   .fill("[" @ strReplace(%sl," ",",") @ "]")   ;
   
   %g_score[%start] = 0;                // Distance from start along optimal path.
   %h_score[%start] = heuristic_estimate_of_distance(%start, %goal);
   %f_score[%start] = %h_score[%start]; // Estimated total distance from start to goal through y.
   
   for(%i=0;%i<openset.getSize();%i++)
   {
      %g_score[openset.getElement(%i)] = "none";
   }
   
   while(openset.getSize() > 0)
   {
      %x_cd = 99999876543210;
      %x = 0;
      %x_i = -1;
      %l = 950000;
      for(%i=0;%i<openset.getSize();%i++)
      {
         %w=openset.getElement(%i);
         %l=heuristic_estimate_of_distance((closedset.getSize() < 1 ? %start : closedset.getElement(closedset.getSize()-1)),%w);
         %s=min(%x_cd,%l);
         if(%s $= %l)
         {
            %x_cd = %l;
            %x = %w;
            %x_i = %i;
            %x_l = %l;
         }
      }
      if(%x $= %goal)
      {
         %array = new ScriptObject(){class="Array";};
         %rpath = reconstruct_path(camefrom, camefrom.getValue(%goal));
         echo("reconstruct output: "@%rpath);
         %array.fill("["@%rpath@"]");
         echo("new array: "@%array.toString(" "));
         return %array;
      }
      openset.remElement(%x_i);
      closedset.addElement(%x);
      %neighbor_nodes[%x] = get_neighbor_nodes(%x,%x.getPosition());
      for(%i=0;%i<getWordCount(%neighbor_nodes[%x]);%i++)
      {
         %y = getWord(%neighbor_nodes[%x],%i);
         if(closedset.contains(%y))
            continue;
         if(%g_score $= "none")
            %tentative_g_score = dist_between(%x,%y);
         else
            %tentative_g_score = %g_score[%x] + dist_between(%x,%y);
         if(!openset.contains(%y))
         {
            openset.addElement(%y);
            %tentative_is_better = true;
         }
         else if(%g_score[%y] $= "none" || %tentative_g_score < %g_score[%y])
            %tentative_is_better = true;
         else
            %tentative_is_better = false;
         
         if(%tentative_is_better $= true)
         {
            camefrom.setValue(%y,%x);
            %g_score[%y] = %tentative_g_score;
            %h_score[%y] = heuristic_estimate_of_distance(%y, %goal);
            %f_score[%y] = %g_score[%y] + %h_score[%y];
         }
      }
   }
   return failure;
}
function reconstruct_path(%came_from, %current_node)
{
   if(strLen(%came_from.getValue(%current_node)) > 0)
   {
      %p = reconstruct_path(%came_from, %came_from.getValue(%current_node));
      return (%p @ "," @ %current_node);
   }
   else
      return %current_node;
}
function getSepL()
{
   for(%i=0;%i<MainBrickGroup.getCount();%i++)
   {
      %bg = MainBrickGroup.getObject(%i);
      for(%x=0;%x<%bg.getCount();%x++)
      {
         %o=%bg.getObject(%x);
         if(%o.getDatablock().PF_isWalkable)
            %a = %a @ %o SPC "";
      }
   }
   return trim(%a);
}
function heuristic_estimate_of_distance(%a,%b)
{
   if(!isObject(%a) || !isObject(%b))
      return 9500000;
   if(%a.getClassName() !$= fxDTSBrick || %b.getClassName() !$= fxDTSBrick)
      return 9500000;
   return vectorDist(%a.getPosition(),%b.getPosition());
}
function dist_between(%a,%b)
{
   return vectorDist(%a.getPosition(),%b.getPosition());
}
function get_neighbor_nodes(%obj,%pos,%avoid)
{
   %g = %obj.getGroup();
   for(%i=0;%i<%g.getCount();%i++)
   {
      %b = %g.getObject(%i);
      if(%b.getDatablock().getName() !$= brickPFNodeData)
         continue;
      %avoid = %obj;
      %tryAgain = 1;
      while(%tryAgain)
	   {
	      %tryAgain = 0;
         %ray = containerRayCast(%obj.getPosition(), %b.getPosition(), $TypeMasks::All, %avoid);
         if(!isObject(%hit = firstWord(%ray)))
            continue;
         if(%hit !$= %b)
         {
            if(%b.getDatablock().getName() !$= brickPFNodeData && !%hit.isColliding())
            {
               %avoid = %avoid @ (strLen(%avoid) > 0 ? " | " : "") @ %hit;
               %tryAgain = 1;
            }
            continue;
         }
         %d = %d @ (strLen(%d)<1 ? "" : " ") @ %b;
	   }
      //if(%a $= %this)
      //   %b.spawnExplosion(wandProjectile,2);
   }
   return trim(%d);
   return Array_toString(%obj," ");
   for(%i=0;%i<4;%i++)
   {
      %startPos = %pos;
      %dist = 7500;
	   switch(%i)
	   {
		   case 0: %endPos = strReplace(%startPos,getWord(%startPos,1),getWord(%startPos,1) + (%dist/2));
		   case 1: %endPos = strReplace(%startPos,getWord(%startPos,0),getWord(%startPos,0) + (%dist/2));
		   case 2: %endPos = strReplace(%startPos,getWord(%startPos,1),getWord(%startPos,1) - (%dist/2));
		   case 3: %endPos = strReplace(%startPos,getWord(%startPos,0),getWord(%startPos,0) - (%dist/2));
	   }
	   %mask = $TypeMasks::All;
	   %dontDoNext = 0;
	   while(!%dontDoNext)
	   {
	      %ray = containerRayCast(%startPos, %endPos, %mask, %avoid);
	      if(!isObject(%pn = getWord(%ray,0)))
	      {
	         %dontDoNext = 1;
	         continue;
	      }
         if(%pn.getClassName() !$= fxDTSBrick)
         {
            %dontDoNext = 1;
            continue;
         }
         %n = %pn.getDatablock().getName();
         if(%n !$= brickPFSpaceData && !%pn.isColliding())
         {
            %avoid = %avoid @ (strLen(%avoid) > 0 ? " | " : "") @ %pn;
            continue;
         }
         else if(%n !$= brickPFSpaceData)
         {
            %dontDoNext = 1;
            continue;
         }
         %d = %d @ (strLen(%d)<1 ? "" : " ") @ %pn;
         %dontDoNext = 1;
	   }
   }
   return %d;
}

function Array::getSize(%this)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   return %this.arraySize;
}
function Array::getElement(%this,%i)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   return %this.arrayElement[%i];
}
function Array::addElement(%this,%dat)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   %this.arrayElement[%this.arraySize] = %dat;
   %this.arraySize++;
}
function Array::remElement(%this,%n)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   if(strLen(%this.arrayElement[%n]) < 1)
      return;
   %this.arrayElement[%n] = "";
   for(%i=0;%i<%this.arraySize;%i++)
   {
      if(%i>%n)
      {
         %this.arrayElement[%i-1] = %this.arrayElement[%i];
         %this.arrayElement[%i] = "";
      }
   }
   %this.arraySize--;
}
function Array::fill(%this,%dat)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   if(getSubStr(%dat,0,1) !$= "[" || getSubStr(%dat,strLen(%dat)-1,1) !$= "]")
      return;
   %dat = strReplace(getSubStr(%dat,1,strLen(%dat)-2),",","\t");
   for(%i=0;%i<getFieldCount(%dat);%i++)
      %this.addElement(getField(%dat,%i));
}
function Array::toString(%this,%sep)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   for(%i=0;%i<%this.arraySize;%i++)
      %dat = %dat @ %this.arrayElement[%i] @ %sep;
   return (strLen(%dat) > 0 ? getSubStr(%dat,0,strLen(%dat)-strLen(%sep)) : "");
}
function Array::clear(%this)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   for(%i=0;%i<%this.arraySize;%i++)
      %this.arrayElement[%i] = "";
   %this.arraySize = 0;
}
function Array::contains(%this,%dat)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   for(%i=0;%i<%this.arraySize;%i++)
      if(%this.arrayElement[%i] $= %dat)
         return true;
   return false;
}
function Array::getValue(%this,%val)
{
   return %this.arrayValue[%val];
}
function Array::setValue(%this,%val,%dat)
{
   %this.arrayValue[%val] = %dat;
}
function Array_getSize(%this)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   return %this.arraySize;
}
function Array::getElement(%this,%i)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   return %this.arrayElement[%i];
}
function Array_addElement(%this,%dat)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   %this.arrayElement[%this.arraySize] = %dat;
   %this.arraySize++;
}
function Array_remElement(%this,%n)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   if(strLen(%this.arrayElement[%n]) < 1)
      return;
   %this.arrayElement[%n] = "";
   for(%i=0;%i<%this.arraySize;%i++)
   {
      if(%i>%n)
      {
         %this.arrayElement[%i-1] = %this.arrayElement[%i];
         %this.arrayElement[%i] = "";
      }
   }
   %this.arraySize--;
}
function Array_fill(%this,%dat)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   if(getSubStr(%dat,0,1) !$= "[" || getSubStr(%dat,strLen(%dat)-1,1) !$= "]")
      return;
   %dat = strReplace(getSubStr(%dat,1,strLen(%dat)-2),",","\t");
   for(%i=0;%i<getFieldCount(%dat);%i++)
      Array_addElement(getField(%dat,%i));
}
function Array_toString(%this,%sep)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   for(%i=0;%i<%this.arraySize;%i++)
      %dat = %dat @ %this.arrayElement[%i] @ %sep;
   return (strLen(%dat) > 0 ? getSubStr(%dat,0,strLen(%dat)-strLen(%sep)) : "");
}
function Array_clear(%this)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   for(%i=0;%i<%this.arraySize;%i++)
      %this.arrayElement[%i] = "";
   %this.arraySize = 0;
}
function Array_contains(%this,%dat)
{
   if(strLen(%this.arraySize) < 1)
      %this.arraySize = 0;
   for(%i=0;%i<%this.arraySize;%i++)
      if(%this.arrayElement[%i] $= %dat)
         return true;
   return false;
}
function Array_getValue(%this,%val)
{
   return %this.arrayValue[%val];
}
function Array_setValue(%this,%val,%dat)
{
   %this.arrayValue[%val] = %dat;
}