function AIPlayer::thinkLoop(%this,%cl)
{
   switch$ (strLwr(%cl.bb_class))
   {
      case BB_CLASS_SCOUT: %this.scoutThink(%cl);
      case BB_CLASS_SOLDIER: %this.soldierThink(%cl);
      case BB_CLASS_PYRO: %this.pyroThink(%cl);
      case BB_CLASS_DEMOMAN: %this.demomanThink(%cl);
      case BB_CLASS_ENGINEER: %this.engineerThink(%cl);
      case BB_CLASS_MEDIC: %this.medicThink(%cl);
      case BB_CLASS_SNIPER: %this.sniperThink(%cl);
   }
}

function AIPlayer::scoutThink(%this,%cl)
{
   cancel(%this.thinkLoop);
   %mi = %this.getMountedImage(0);
   if(!isObject(%mi) || %mi.getName() !$= tf2_scattergunImage)
   {
      %this.mountImage(tf2_scattergunImage,0);
      fixArmReady(%this);
   }
   if(strLen($maxScoutScatterDist) < 1)
      $maxScoutScatterDist = 32;
   if(!isObject(%this.botAttackTarget) || %this.botAttackTarget.getState() $= Dead)
   {
      for(%i=0;%i<ClientGroup.getCount();%i++)
      {
         %fc = ClientGroup.getObject(%i);
         if(%cl.bb_team $= %fc.bb_team)
            continue;
         if(!isObject(%fc.player))
            continue;
         if(%fc.player.getState() $= Dead)
            continue;
         %mePos = %this.getPosition();
         %thPos = %fc.player.getPosition();
         %dist = vectorDist(%mePos,%thPos);
         if(%dist > $maxScoutScatterDist)
            continue;
         if($DEBUG)
            announce(" found: "@(%fc.bb_team$=BB_TEAM_RED?"\c0":"\c1")@%fc.name@"\c3 | dist: "@%dist@" | maxdist: "@$maxPyroFlameDist);
         if(strLen(%mindist) < 1 || %dist < %mindist)
         {
            %mindist = %dist;
            %distobj = %fc.player;
         }
      }
      for(%i=0;%i<globalBotUserGroup.getCount();%i++)
      {
         %fc = globalBotUserGroup.getObject(%i);
         if(%cl.bb_team $= %fc.bb_team)
            continue;
         if(!isObject(%fc.player))
            continue;
         if(%fc.player.getState() $= Dead)
            continue;
         %mePos = %this.getPosition();
         %thPos = %fc.player.getPosition();
         %dist = vectorDist(%mePos,%thPos);
         if(%dist > $maxScoutScatterDist)
            continue;
         if($DEBUG)
            announce(" found: "@(%fc.bb_team$=BB_TEAM_RED?"\c0":"\c1")@%fc.name@"\c3 | dist: "@%dist@" | maxdist: "@$maxPyroFlameDist);
         if(strLen(%mindist) < 1 || %dist < %mindist)
         {
            %mindist = %dist;
            %distobj = %fc.player;
         }
      }
      if(isObject(%distObj))
      {
         %this.botAttackTarget = %distObj;
      }
   }
   else
   {
      if(vectorDist(%this.getPosition(),%this.botAttackTarget.getPosition()) > $maxPyroFlameDist)
         %this.botAttackTarget = 0;
      else
      {
         %this.setAimLocation(%this.botAttackTarget.getEyePoint());
         %this.setMoveDestination(%this.botAttackTarget.getPosition());
         if(%this.getImageTrigger(0) $= 1)
            %this.setImageTrigger(0,0);
         else
            %this.setImageTrigger(0,1);
      }
   }
   %this.thinkLoop = %this.schedule(10,scoutThink,%cl);
}

function AIPlayer::soldierThink(%this,%cl)
{
   cancel(%this.thinkLoop);
   %mi = %this.getMountedImage(0);
   if(!isObject(%mi) || %mi.getName() !$= tf2_rocketImage)
   {
      %this.mountImage(tf2_rocketImage,0);
      fixArmReady(%this);
   }
   if(strLen($maxSoldierBoomDist) < 1)
      $maxSoldierBoomDist = 84;
   if(!isObject(%this.botAttackTarget) || %this.botAttackTarget.getState() $= Dead)
   {
      for(%i=0;%i<ClientGroup.getCount();%i++)
      {
         %fc = ClientGroup.getObject(%i);
         if(%cl.bb_team $= %fc.bb_team)
            continue;
         if(!isObject(%fc.player))
            continue;
         if(%fc.player.getState() $= Dead)
            continue;
         %mePos = %this.getPosition();
         %thPos = %fc.player.getPosition();
         %dist = vectorDist(%mePos,%thPos);
         if(%dist > $maxSoldierBoomDist)
            continue;
         if($DEBUG)
            announce(" found: "@(%fc.bb_team$=BB_TEAM_RED?"\c0":"\c1")@%fc.name@"\c3 | dist: "@%dist@" | maxdist: "@$maxPyroFlameDist);
         if(strLen(%mindist) < 1 || %dist < %mindist)
         {
            %mindist = %dist;
            %distobj = %fc.player;
         }
      }
      for(%i=0;%i<globalBotUserGroup.getCount();%i++)
      {
         %fc = globalBotUserGroup.getObject(%i);
         if(%cl.bb_team $= %fc.bb_team)
            continue;
         if(!isObject(%fc.player))
            continue;
         if(%fc.player.getState() $= Dead)
            continue;
         %mePos = %this.getPosition();
         %thPos = %fc.player.getPosition();
         %dist = vectorDist(%mePos,%thPos);
         if(%dist > $maxSoldierBoomDist)
            continue;
         if($DEBUG)
            announce(" found: "@(%fc.bb_team$=BB_TEAM_RED?"\c0":"\c1")@%fc.name@"\c3 | dist: "@%dist@" | maxdist: "@$maxPyroFlameDist);
         if(strLen(%mindist) < 1 || %dist < %mindist)
         {
            %mindist = %dist;
            %distobj = %fc.player;
         }
      }
      if(isObject(%distObj))
      {
         %this.botAttackTarget = %distObj;
      }
   }
   else
   {
      if(vectorDist(%this.getPosition(),%this.botAttackTarget.getPosition()) > $maxPyroFlameDist)
         %this.botAttackTarget = 0;
      else
      {
         %this.setAimLocation(%this.botAttackTarget.getEyePoint());
         %this.setMoveDestination(%this.botAttackTarget.getPosition());
         if(%this.getImageTrigger(0) $= 1)
            %this.setImageTrigger(0,0);
         else
            %this.setImageTrigger(0,1);
      }
   }
   %this.thinkLoop = %this.schedule(10,soldierThink,%cl);
}

function AIPlayer::pyroThink(%this,%cl)
{
   cancel(%this.thinkLoop);
   %mi = %this.getMountedImage(0);
   if(!isObject(%mi) || %mi.getName() !$= tf2_flamethrowerImage)
   {
      %this.mountImage(tf2_flamethrowerImage,0);
      fixArmReady(%this);
   }
   if(strLen($maxPyroFlameDist) < 1)
      $maxPyroFlameDist = 5;
   if(!isObject(%this.botAttackTarget) || %this.botAttackTarget.getState() $= Dead)
   {
      for(%i=0;%i<ClientGroup.getCount();%i++)
      {
         %fc = ClientGroup.getObject(%i);
         if(%cl.bb_team $= %fc.bb_team)
            continue;
         if(!isObject(%fc.player))
            continue;
         if(%fc.player.getState() $= Dead)
            continue;
         %mePos = %this.getPosition();
         %thPos = %fc.player.getPosition();
         %dist = vectorDist(%mePos,%thPos);
         if(%dist > $maxPyroFlameDist)
            continue;
         if($DEBUG)
            announce(" found: "@(%fc.bb_team$=BB_TEAM_RED?"\c0":"\c1")@%fc.name@"\c3 | dist: "@%dist@" | maxdist: "@$maxPyroFlameDist);
         if(strLen(%mindist) < 1 || %dist < %mindist)
         {
            %mindist = %dist;
            %distobj = %fc.player;
         }
      }
      for(%i=0;%i<globalBotUserGroup.getCount();%i++)
      {
         %fc = globalBotUserGroup.getObject(%i);
         if(%cl.bb_team $= %fc.bb_team)
            continue;
         if(!isObject(%fc.player))
            continue;
         if(%fc.player.getState() $= Dead)
            continue;
         %mePos = %this.getPosition();
         %thPos = %fc.player.getPosition();
         %dist = vectorDist(%mePos,%thPos);
         if(%dist > $maxPyroFlameDist)
            continue;
         if($DEBUG)
            announce(" found: "@(%fc.bb_team$=BB_TEAM_RED?"\c0":"\c1")@%fc.name@"\c3 | dist: "@%dist@" | maxdist: "@$maxPyroFlameDist);
         if(strLen(%mindist) < 1 || %dist < %mindist)
         {
            %mindist = %dist;
            %distobj = %fc.player;
         }
      }
      if(isObject(%distObj))
      {
         %this.botAttackTarget = %distObj;
      }
   }
   else
   {
      if(vectorDist(%this.getPosition(),%this.botAttackTarget.getPosition()) > $maxPyroFlameDist)
         %this.botAttackTarget = 0;
      else
      {
         %this.setAimLocation(%this.botAttackTarget.getEyePoint());
         %this.setMoveDestination(%this.botAttackTarget.getPosition());
         if(%this.getImageTrigger(0) !$= 1)
            %this.setImageTrigger(0,1);
      }
   }
   %this.thinkLoop = %this.schedule(10,pyroThink,%cl);
}

function AIPlayer::demomanThink(%this,%cl)
{
   cancel(%this.thinkLoop);
   %mi = %this.getMountedImage(0);
   if(!isObject(%mi) || %mi.getName() !$= tf2_pipeLauncherImage)
   {
      %this.mountImage(tf2_pipeLauncherImage,0);
      fixArmReady(%this);
   }
   if(strLen($maxDemomanPipeDist) < 1)
      $maxDemomanPipeDist = 16;
   if(!isObject(%this.botAttackTarget) || %this.botAttackTarget.getState() $= Dead)
   {
      for(%i=0;%i<ClientGroup.getCount();%i++)
      {
         %fc = ClientGroup.getObject(%i);
         if(%cl.bb_team $= %fc.bb_team)
            continue;
         if(!isObject(%fc.player))
            continue;
         if(%fc.player.getState() $= Dead)
            continue;
         %mePos = %this.getPosition();
         %thPos = %fc.player.getPosition();
         %dist = vectorDist(%mePos,%thPos);
         if(%dist > $maxDemomanPipeDist)
            continue;
         if($DEBUG)
            announce(" found: "@(%fc.bb_team$=BB_TEAM_RED?"\c0":"\c1")@%fc.name@"\c3 | dist: "@%dist@" | maxdist: "@$maxPyroFlameDist);
         if(strLen(%mindist) < 1 || %dist < %mindist)
         {
            %mindist = %dist;
            %distobj = %fc.player;
         }
      }
      for(%i=0;%i<globalBotUserGroup.getCount();%i++)
      {
         %fc = globalBotUserGroup.getObject(%i);
         if(%cl.bb_team $= %fc.bb_team)
            continue;
         if(!isObject(%fc.player))
            continue;
         if(%fc.player.getState() $= Dead)
            continue;
         %mePos = %this.getPosition();
         %thPos = %fc.player.getPosition();
         %dist = vectorDist(%mePos,%thPos);
         if(%dist > $maxDemomanPipeDist)
            continue;
         if($DEBUG)
            announce(" found: "@(%fc.bb_team$=BB_TEAM_RED?"\c0":"\c1")@%fc.name@"\c3 | dist: "@%dist@" | maxdist: "@$maxPyroFlameDist);
         if(strLen(%mindist) < 1 || %dist < %mindist)
         {
            %mindist = %dist;
            %distobj = %fc.player;
         }
      }
      if(isObject(%distObj))
      {
         %this.botAttackTarget = %distObj;
      }
   }
   else
   {
      if(vectorDist(%this.getPosition(),%this.botAttackTarget.getPosition()) > $maxPyroFlameDist)
         %this.botAttackTarget = 0;
      else
      {
         %this.setAimLocation(%this.botAttackTarget.getEyePoint());
         %this.setMoveDestination(%this.botAttackTarget.getPosition());
         if(%this.getImageTrigger(0) $= 1)
            %this.setImageTrigger(0,0);
         else
            %this.setImageTrigger(0,1);
      }
   }
   %this.thinkLoop = %this.schedule(10,demomanThink,%cl);
}

function AIPlayer::engineerThink(%this,%cl)
{
   cancel(%this.thinkLoop);
   %mi = %this.getMountedImage(0);
   if(!isObject(%mi) || %mi.getName() !$= PlaceSentryImage)
   {
      %this.mountImage(PlaceSentryImage,0);
      fixArmReady(%this);
   }
   if(%this.getImageTrigger(0) !$= 1)
      %this.setImageTrigger(0,1);
   %this.thinkLoop = %this.schedule(10,engineerThink,%cl);
}
function AIPlayer::medicThink(%this,%cl)
{
   cancel(%this.thinkLoop);
   %mi = %this.getMountedImage(0);
   if(!isObject(%mi) || %mi.getName() !$= tf2_medigunImage)
   {
      %this.mountImage(tf2_medigunImage,0);
      fixArmReady(%this);
   }
   if(strLen($maxHealDist) < 1)
      $maxHealDist = 5;
   if(!isObject(%this.botHealTarget) || %this.botHealTarget.getState() $= Dead)
   {
      for(%i=0;%i<ClientGroup.getCount();%i++)
      {
         %fc = ClientGroup.getObject(%i);
         if(%cl.bb_team !$= %fc.bb_team)
            continue;
         if(!isObject(%fc.player))
            continue;
         if(%fc.player.getState() $= Dead)
            continue;
         %dist = vectorDist(%this.getPosition(), %fc.player.getPosition());
         if(%dist > $maxHealDist)
            continue;
         if(strLen(%mindist) < 1 || %dist < %mindist)
         {
            %mindist = %dist;
            %distobj = %fc.player;
         }
      }
      if(isObject(%distObj))
      {
         %this.botHealTarget = %distObj;
      }
   }
   else
   {
      if(vectorDist(%this.getPosition(),%this.botHealTarget.getPosition()) > $maxHealDist)
      {
         if($DEBUG)
            announce("   too far away, removing.");
         %this.botHealTarget = 0;
      }
      else
      {
      //%this.setAimObject(%this.healTarget);
      //%this.setMoveObject(%this.healTarget);
      %this.setAimLocation(%this.botHealTarget.getEyePoint());
      %this.setMoveDestination(vectorAdd(%this.botHealTarget.getPosition(),"3 0 0"));
      if(%this.getImageTrigger(0) !$= 1)
         %this.setImageTrigger(0,1);
      }
   }
   %this.thinkLoop = %this.schedule(10,medicThink,%cl);
}

function AIPlayer::sniperThink(%this,%cl)
{
   cancel(%this.thinkLoop);
   %mi = %this.getMountedImage(0);
   if(!isObject(%mi) || %mi.getName() !$= tf2_sniperImage)
   {
      %this.mountImage(tf2_sniperImage,0);
      fixArmReady(%this);
   }
   if(strLen($maxSniperPowDist) < 1)
      $maxSniperPowDist = 6400;
   if(!isObject(%this.botAttackTarget) || %this.botAttackTarget.getState() $= Dead)
   {
      for(%i=0;%i<ClientGroup.getCount();%i++)
      {
         %fc = ClientGroup.getObject(%i);
         if(%cl.bb_team $= %fc.bb_team)
            continue;
         if(!isObject(%fc.player))
            continue;
         if(%fc.player.getState() $= Dead)
            continue;
         %mePos = %this.getPosition();
         %thPos = %fc.player.getPosition();
         %dist = vectorDist(%mePos,%thPos);
         if(%dist > $maxSniperPowDist)
            continue;
         if($DEBUG)
            announce(" found: "@(%fc.bb_team$=BB_TEAM_RED?"\c0":"\c1")@%fc.name@"\c3 | dist: "@%dist@" | maxdist: "@$maxPyroFlameDist);
         if(strLen(%mindist) < 1 || %dist < %mindist)
         {
            %mindist = %dist;
            %distobj = %fc.player;
         }
      }
      for(%i=0;%i<globalBotUserGroup.getCount();%i++)
      {
         %fc = globalBotUserGroup.getObject(%i);
         if(%cl.bb_team $= %fc.bb_team)
            continue;
         if(!isObject(%fc.player))
            continue;
         if(%fc.player.getState() $= Dead)
            continue;
         %mePos = %this.getPosition();
         %thPos = %fc.player.getPosition();
         %dist = vectorDist(%mePos,%thPos);
         if(%dist > $maxSniperPowDist)
            continue;
         if($DEBUG)
            announce(" found: "@(%fc.bb_team$=BB_TEAM_RED?"\c0":"\c1")@%fc.name@"\c3 | dist: "@%dist@" | maxdist: "@$maxPyroFlameDist);
         if(strLen(%mindist) < 1 || %dist < %mindist)
         {
            %mindist = %dist;
            %distobj = %fc.player;
         }
      }
      if(isObject(%distObj))
      {
         %this.botAttackTarget = %distObj;
      }
   }
   else
   {
      if(vectorDist(%this.getPosition(),%this.botAttackTarget.getPosition()) > $maxPyroFlameDist)
         %this.botAttackTarget = 0;
      else
      {
         %this.setAimLocation(%this.botAttackTarget.getEyePoint());
         %this.setMoveDestination(%this.botAttackTarget.getPosition());
         if(%this.getImageTrigger(0) $= 1)
            %this.setImageTrigger(0,0);
         else
            %this.setImageTrigger(0,1);
      }
   }
   %this.thinkLoop = %this.schedule(10,sniperThink,%cl);
}