function makeBot(%pos,%team)
{
   if(!isObject(globalBotGroup))
      new SimSet(globalBotGroup);
   %bot = new AIPlayer()
   {
      position = %pos;
      datablock = playerNoJet;
      isBastionBot = 1;
      shapename = fetchBotName();
      bb_team = %team;
   };
   %bot.shapename();
   %bot.emptyshape.setShapeNameColor((%team $= BB_TEAM_RED ? "1 0 0" : "0 0 1") SPC 1);
   globalBotGroup.add(%bot);
}

function serverCmdBastionBot(%cl,%team,%class)
{
   if(%cl.isAdmin)
   {
      %conn = new AIConnection()
      {
         name = fetchBotName();
         bl_id = -1;
         bb_team = "BB_TEAM_" @ %team;
         bb_teamui = %team;
         bb_class = "BB_CLASS_" @ %class;
         bb_classui = %class;
      };
      %tu = (%team $= "RED" ? "\c0" : "\c1") @ strupr(%team);
      %nu = %cl.name;
      %cu = "\c6" @ strlwr(%class);
      announce(%nu SPC "\c6added a" SPC %tu SPC %cu SPC "\c6bot.");
      messageAll('msgClientJoin',"\c1" @ %conn.name SPC "connected.");
      %conn.onInit();
   }
}

function serverCmdClearBastionBots(%cl)
{
   if(%cl.isAdmin)
   {
      if(!isObject(globalBotUserGroup))
         return;
      messageAll('MsgClearBricks',"\c3"@%cl.name@" \c6cleared all Bastion Bots.");
      while(globalBotUserGroup.getCount() > 0)
      {
         %c = globalBotUserGroup.getObject(0);
         if(isObject(%c.player))
            %c.player.delete();
         globalBotUserGroup.remove(%c);
      }
   }
}

package BB_system_makeBot
{
   function Armor::onRemove(%this,%obj)
   {
      if(isObject(%obj.emptyshape))
         %obj.emptyshape.delete();
      Parent::onRemove(%this,%obj);
   }
};
activatePackage(BB_system_makeBot);
announce("makeBot end exec");