if(!$BB::SUPPORT::registerBuilding)
   exec($BB::Path @ "/scripts/classes/engineer/support_registerBuilding.cs");

registerBuildingType("dispenser",3,200,100,"150 180 216");
function BB_Building_Dispenser_1::onAdd(%this,%obj)
{
   %obj.bb_ammo = 0;
   %obj.bb_maxAmmo = 15;
   %obj.bb_lastAmmoIncrease = 0;
   %obj.bb_increaseSpeed1 = 5;
   %obj.bb_increaseSpeed2 = 2;
   %obj.bb_increaseSpeed3 = 1;
   %obj.increaseAmmo();
   %obj.dispense(true);
   %obj.handleDispensing();
   %obj.shapename();
}

function SimObject::increaseAmmo(%this)
{
   cancel(%this.increaseAmmo);
   if(%this.getState() $= Dead)
   {
      %this.shapename = "";
      return;
   }
   %increase = 1;
   if(%this.bb_ammo < %this.bb_maxAmmo)
      if(%this.bb_ammo + %increase <= %this.bb_maxAmmo)
         %this.bb_ammo = %this.bb_ammo + %increase;
      else if(%this.bb_ammo + %increase > %this.bb_maxAmmo)
         %this.bb_ammo = %this.bb_maxAmmo;
   else
      %this.bb_ammo = %this.bb_maxAmmo;
   %this.shapename = "Ammo:" SPC %this.bb_ammo;
   %this.bb_lastAmmoIncrease = $Sim::Time;
   %this.increaseAmmo = %this.schedule(%this.bb_increaseSpeed[%this.bb_upgradeLevel] * 1000,increaseAmmo);
}

function SimObject::dispense(%this,%boot)
{
   cancel(%this.dispense);
   if(%this.getState() $= Dead)
   {
      return;
   }
   %this.shapename = "Ammo:" SPC %this.bb_ammo;
   if(!isObject(%this.userSimSet)) %this.userSimSet = new SimSet();
   %mask = ($TypeMasks::PlayerObjectType);
   initContainerBoxSearch(%this.getPosition(), "32 32 32", %mask);
   while(isObject(%searchObj = containerSearchNext()) && %this.bb_ammo > 0)
   {
      if((!isObject(%searchObj)) || (!isObject(%searchObj.client))) continue;
      %dist = vectorDist(%this.getPosition(),%searchObj.getPosition());
      if(%dist > 5 || %this.userSimSet.isMember(%searchObj))
         continue;
      if(%searchObj.client.bb_team !$= %this.bb_team)
         continue;
      %this.startDispensingObj(%searchObj);
   }
   %this.dispense = %this.schedule(100,dispense,false);
}
function SimObject::handleDispensing(%this)
{
   cancel(%this.handleDispensing);
   if(%this.getState() $= Dead)
   {
      return;
   }
   if(isObject(%this.userSimSet))
   {
      for(%i=0;%i<%this.userSimSet.getCount();%i++)
      {
         %obj = %this.userSimSet.getObject(%i);
         %dist = vectorDist(%this.getPosition(),%obj.getPosition());
         if(%dist > 5)
         {
            %this.stopDispensingObj(%obj);
            if(%i == %this.userSimSet.getCount())
               break;
            continue;
         }
         if(%obj.getDamageLevel() >= 15)
            %obj.setDamageLevel(%obj.getDamageLevel() - 15);
         else if(%obj.getDamageLevel() < 15)
            %obj.setDamageLevel(0);
         if($Sim::Time - %this.lastAmmoDispense[%obj] >= 0.75)
         {
            // DISPENSE AMMO
            if(%obj.client.bb_screws < 200 && %this.bb_ammo > 0)
            {
               %screws = getRandom(15,40);
               if(%obj.client.bb_screws < 200-%screws)
                  %obj.client.bb_screws = %obj.client.bb_screws + %screws;
               else if(%obj.client.bb_screws >= 200-%screws)
                  %obj.client.bb_screws = 200;
               %this.bb_ammo--;
            }
            %this.lastAmmoDispense[%obj] = $Sim::Time;
         }
         //%this.bb_ammo--;
         doHealBeam(%this,%obj);
      }
   }
   %this.handleDispensing = %this.schedule(50,handleDispensing);
}
function SimObject::stopDispensingObj(%this,%obj)
{
   // enough with the fancy emitter stuff
   %this.userSimSet.remove(%obj);
}
function SimObject::startDispensingObj(%this,%obj)
{
   serverPlay3D(TF2MedigunActivateSound,%this.getPosition());
   serverPlay3D(TF2MedigunActivateSound,%obj.getPosition());
   %this.userSimSet.add(%obj);
}