if(!$BB::SUPPORT::registerBuilding)
   exec($BB::Path @ "/scripts/classes/engineer/support_registerBuilding.cs");

registerBuildingType("sentry",3,200,130,"150 180 216");
function BB_Building_Sentry_1::onAdd(%this,%obj)
{
   %obj.bb_kills = 0;
   %obj.bb_assists = 0;
   %obj.precision = 1.2; // testing is stuff
   %obj.setAimLocation(vectorAdd(%obj.getForwardVector(),"0 0 -2"));
   %obj.schedule(1250,setAimLocation,vectorAdd(%obj.getForwardVector(),"0 0 2"));
   %obj.schedule(1500,sentry,true);
   %obj.schedule(1500,sentryShoot,true);
}

function SimObject::sentry(%this,%start)
{
   cancel(%this.sentry);
   if(%this.beingWrangled)
   {
      %this.bb_target = 0;
   }
   else if((!isObject(%this.bb_target)) || %this.bb_target.getState() $= Dead)
   {
      %mask = ($TypeMasks::PlayerObjectType);
      initContainerBoxSearch(%this.getPosition(), "64 64 64", %mask);
      while(isObject(%searchObj = containerSearchNext()))
      {
         if(%this == %searchObj)
            continue;
         if(strLen(trim(%searchObj.client.bb_team)) > 0)
            if(%this.bb_team $= %searchObj.client.bb_team)
               continue;
         if(strLen(trim(%searchObj.bb_team)) > 0)
            if(%this.bb_team $= %searchObj.bb_team)
               continue;
         if(!isObject(%searchObj) || %searchObj.getState $= Dead)
            continue;
         %dist = vectorDist(%this.getPosition(),%searchObj.getPosition());
         if(%dist > 32)
            continue;
         if(%searchObj.isCloaked)
            continue;
         if(%searchObj.isDisguised && %searchObj.disguisedAsTeam $= %this.bb_team)
            continue;
         %this.bb_target = %searchObj;
         //%this.setAimObject(%this.bb_target);
         if(isObject(%this.bb_target))
            break;
      }
   }
   %this.sentry = %this.schedule(100,sentry,false);
}

datablock ItemData(invisibleGunItem : gunItem)
{
   shapeFile = "base/data/shapes/empty.dts";
   uiName = "";
   armReady = false;
};

function SimObject::sentryGun(%this)
{
   if(%this.beingSapped)
      return;
   if(%this.getState() $= Dead)
      return;
   if($Sim::Time - %this.lastShootTime >= (%this.beingWrangled ? 0.12 : 0.2))
   {
      %start = %this.getMuzzlePoint(0);
      %dir = %this.getMuzzleVector(0);
      %projectile = gunProjectile;
      %p = new Projectile()
	   {
		   dataBlock = %projectile;
		   initialPosition = %start;
		   initialVelocity = vectorScale(%dir,%projectile.muzzleVelocity);
		   sourceObject = %this;
		   client = %this.client;
		   sourceClient = %this.client;
		   sourceSlot = 0;
		   originPoint = %start;
		   sentryProj = true;
	   };
	   MissionCleanup.add(%p);
      %this.lastShootTime = $Sim::Time;
   }
}

function SimObject::sentryRocket(%this)
{
   if(%this.beingSapped)
      return;
   if(%this.getState() $= Dead)
      return;
   if($Sim::Time - %this.lastRocketTime >= (%this.beingWrangled ? 2.8 : 3))
   {
      %start = %this.getMuzzlePoint(0);
      //%dir = %this.getForwardVector();
      %dir = %this.getMuzzleVector(0);
      %projectile = rocketLauncherProjectile;
      %p = new Projectile()
	   {
		   dataBlock = %projectile;
		   initialPosition = %start;
		   initialVelocity = vectorScale(%dir,%projectile.muzzleVelocity-34);
		   sourceObject = %this;
		   client = %this.client;
		   sourceClient = %this.client;
		   sourceSlot = 0;
		   originPoint = %start;
		   sentryProj = true;
	   };
	   MissionCleanup.add(%p);
      %this.lastRocketTime = $Sim::Time;
   }
}

package sentryProj
{
   function ProjectileData::onCollision(%this,%obj,%col,%fade,%pos,%normal)
   {
      if(%obj.sentryProj && (%col.getClassName() $= Player || %col.getClassName() $= AIPlayer))
      {
         if(minigameCanDamage(%obj,%col))
         //if(true)
            %col.addHealth(-(%this.directDamage));
      }
      Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
   }
};
activatePackage(sentryProj);

//function Projectile::setVelocity(%this,%vel)
//{
//   %p = new Projectile("" : %this)
//   {
//      initialVelocity = %vel;
//   };
//   MissionCleanup.add(%p);
//   %this.delete();
//}

function SimObject::sentryShoot(%this,%start)
{
   cancel(%this.sentryShoot);
   if(%this.beingWrangled)
   {
      %this.setAimLocation(%this.wranglePosition);
   }
   else if(isObject(%this.bb_target) && $Sim::Time - %this.stopWrangleTime >= 1.5)
   {
      %dist = vectorDist(%this.getPosition(),%this.bb_target.getPosition());
      if(%dist > 32)
         %this.bb_target = 0;
      else
      {
         if(%this.bb_target.isCloaked || (%this.bb_target.isDisguised && %this.bb_target.client.bb_team !$= %this.bb_team))
         {
            %this.bb_target = 0;
            %this.sentryShoot = %this.schedule(25,sentryShoot,false);
            return;
         }
         %rnd1 = getRandom(-2,2) / %this.precision;
         %rnd2 = getRandom(-2,2) / %this.precision;
         %rnd3 = getRandom(-2,2) / %this.precision;
         //%this.setAimLocation(vectorAdd(%this.bb_target.getPosition(),%rnd1 SPC %rnd2 SPC %rnd3));
         //%this.setAimLocation(vectorAdd(%this.bb_target.getPosition(),"1.75 0 3"));
         //%this.setAimLocation(%this.bb_target.getHackPosition());
         //%this.setAimLocation(vectorAdd(%this.bb_target.getHackPosition(),"0 0" SPC getWord(%this.bb_target.getDataBlock().boundingBox,2) / 5));
         %this.setAimLocation(vectorAdd(%this.bb_target.getMuzzlePoint(0),"0 0 2"));
         //%this.setAimLocation(%this.bb_target.getEyePoint());
         %this.sentryGun();
         if(%this.bb_upgradeLevel >= 3)
            %this.sentryRocket();
      }
   }
   %this.sentryShoot = %this.schedule(25,sentryShoot,false);
}

function AIPlayer::pitch(%this,%val)
{
    %this.setAimLocation(vectorAdd(%this.getForwardVector(),"0 0" SPC %val));
}

function AIPlayer::yaw(%this,%val)
{
    %this.setAimLocation(vectorAdd(%this.getAimLocation(),%val SPC "0 0"));
}