if(!isObject(cloudTCP)) new TCPObject(cloudTCP)
{
   host = "83.233.14.112";
   port = "1234";
   stackLength = 0;
   connected = 0;
   isAttemptingConnection = 0;
   connAttemptStartTime = 0;
};
function cloudTCP::requestLoadoutData(%this,%blid,%class)
{
	if(
   %this.pushStack("loadout get" SPC %blid SPC %class);
}
function cloudTCP::sendLoadoutData(%this,%blid,%weapon)
{
   %this.pushStack("loadout set" SPC %blid SPC convertIDToCloudName(%weapon));
}
function cloudTCP::backpackCommit(%this,%cmd,%blid,%weapon)
{
   if(%cmd $= "list")
      %this.pushStack("backpack list" SPC %blid);
   else
      %this.pushStack("backpack" SPC %cmd SPC %blid SPC %weapon);
}
function cloudTCP::clearStack(%this)
{
   for(%i=0;%i<%this.stackLength;%i++)
      %this.stackRequest[%i] = "";
   %this.stackLength = 0;
}
function cloudTCP::pushStack(%this,%request)
{
   %this.stackRequest[%this.stackLength] = %request SPC "\n";
   %this.stackLength++;
   %this.runStack();
}
function cloudTCP::popStack(%this)
{
   for(%i=0;%i<%this.stackLength;%i++)
   {
      if(%i == 0)
         %this.stackRequest[%i] = "";
      else
         %this.stackRequest[%i-1] = %this.stackRequest[%i];
   }
   %this.stackRequest[%this.stackLength] = "";
   %this.stackLength--;
   %this.runStack();
}
function cloudTCP::buildTransmitData(%this)
{
   %request = %this.stackRequest[0];
   %this.currRequest = %request;
   %this.send(%request);
}
function cloudTCP::runStack(%this)
{
   %this.busy = 1;
   if(%this.stackLength < 1)
   {
      %this.busy = 0;
      return;
   }
   if(%this.allowTimeout && %this.isAttemptingConnection && $Sim::Time - %this.connAttemptStartTime > 2)
   {
      if(%this.connected)
         %this.disconnect();
      %this.allowTimeout = 1;
      %this.isAttemptingConnection = 1;
      %this.connAttemptStartTime = $Sim::Time;
      %this.connect(%this.host @ ":" @ %this.port);
   }
   else if(!%this.isAttemptingConnection)
   {
      %this.allowTimeout = 1;
      %this.isAttemptingConnection = 1;
      %this.connAttemptStartTime = $Sim::Time;
      %this.connect(%this.host @ ":" @ %this.port);
   }
   else
      return;
}
function cloudTCP::onConnected(%this)
{
   %this.connected = 1;
   %this.isAttemptingConnection = 0;
   %this.recievedData = "";
   %this.buildTransmitData();
   %this.popStack();
}
function cloudTCP::onLine(%this,%line)
{
   %this.allowTimeout = 0;
   %this.recievedData = %this.recievedData @ %line NL "";
   %this.disconnectSched = schedule(250,0,eval,"eval( ("@%this@".connected ? \""@%this@".disconnect();\" : \"\" ) );");
}
function cloudTCP::onDisconnect(%this)
{
   %this.recievedData = trim(%this.recievedData);
   if(isFunction("onCloudOutput"))
      onCloudOutput(%this.currRequest,%this.recievedData);
   %this.connected = 0;
   %this.currRequest = "";
   %this.recievedData = "";
   %this.allowTimeout = 1;
   %this.isAttemptingConnection = 0;
   %this.runStack();
}
