datablock TriggerData(BBCapPointTriggerData)
{
	tickPeriodMS = 100;
};
if(!isFunction("registerBlockBastionSpecial"))
   exec("../a_execfirst.cs");
registerBlockBastionSpecial("CP_SetCap",setBrickAsCap,"list None 0 RED 1 BLU 2\tstring 255 75");
function setBrickAsCap(%obj,%args)
{
   %team = getField(%args,0);
   switch (%team)
   {
      case 0: %team = NONE;
      case 1: %team = BB_TEAM_RED;
      case 2: %team = BB_TEAM_BLU;
      default: %team = NONE;
   }
   %name = getField(%args,1);
   if(!isObject(globalCapturePointGroup))
      new SimSet(globalCapturePointGroup);
   globalCapturePointGroup.add(%obj);
   %obj.isCap = 1;
   %obj.capName = %name;
   %obj.capTeam = %team;
   %obj.capForce = (%team $= BB_TEAM_RED ? -100 : (%team $= BB_TEAM_BLU ? 100 : 0));
   %obj.createTriggerZone(BBCapPointTriggerData);
}
function BBCapPointTriggerData::onEnterTrigger(%this, %obj, %user) {
   %user.capCPLoop(%obj);
}
function BBCapPointTriggerData::onLeaveTrigger(%this, %obj, %user) {
   cancel(%user.capCPLoop[%obj]);
}
function Player::capCPLoop(%this,%obj) {
   cancel(%this.capCPLoop[%obj]);
   cancel(%obj.decreaseCaptureLoop);
   if(%this.getState() $= Dead)
      return;
   if(!isObject(%obj))
      return;
   if(%this.client.bb_class $= BB_CLASS_SCOUT)
      %capSpeed = 2;
   else
      %capSpeed = 1;
   for(%i=0;%i<%obj.getNumObjects();%i++) {
      %a = %obj.getObject(%i);
      if(%a.client $= %this.client)
         continue;
      if(%a.getState() $= Dead)
         continue;
      if(%a.client.bb_team !$= %this.client.bb_team)
         %isEnemy = true;
   }
   if(%isEnemy)
      commandToClient(%this.client,'centerPrint',"\n\n\n\n\n\n\n\c3Capture blocked by enemy.", 1);
   else {
      if(%obj.spawnBrick.capTeam $= %this.client.bb_team)
         commandToClient(%this.client,'centerPrint',"\n\n\n\n\n\n\n\c3Defend this point.", 1);
      else {
         if(%this.client.bb_team $= BB_TEAM_RED) {
            if(%obj.spawnBrick.capTeam $= BB_TEAM_RED || %obj.spawnBrick.capForce <= -100) {
               %obj.spawnBrick.capForce = 0;
               %obj.spawnBrick.capTeam = BB_TEAM_RED;
               messageAll('',"\c0RED \c6has captured \c3" @ %obj.spawnBrick.capName @ "\c6!");
            }
            else {
               %obj.spawnBrick.capForce -= %capSpeed;
               %pcnt = (-100 - %obj.spawnBrick.capForce) + 100;
               commandToClient(%this.client,'centerPrint',"\n\n\n\n\n\n\n\c3Capture: \c6"@%pcnt@"%.", 1);
            }
         }
         else if(%this.client.bb_team $= BB_TEAM_BLU) {
            if(%obj.spawnBrick.capTeam $= BB_TEAM_BLU || %obj.spawnBrick.capForce >= 100) {
               %obj.spawnBrick.capForce = 0;
               %obj.spawnBrick.capTeam = BB_TEAM_BLU;
               messageAll('',"\c1BLU \c6has captured \c3" @ %obj.spawnBrick.capName @ "\c6!");
            }
            else {
               %obj.spawnBrick.capForce += %capSpeed;
               %pcnt = %obj.spawnBrick.capForce;
               commandToClient(%this.client,'centerPrint',"\n\n\n\n\n\n\n\c3Capture: \c6"@%pcnt@"%.", 1);
            }
         }
            
      }
   }
   %obj.decreaseCaptureLoop = schedule(30000, 0, decreaseCaptureLoop, %obj);
   %this.capCPLoop[%obj] = %this.schedule(200, capCPLoop, %obj);
}
function decreaseCaptureLoop(%obj) {
   cancel(%obj.decreaseCaptureLoop);
   if(%obj.spawnBrick.capForce > 0)
      %obj.spawnBrick.capForce--;
   else if(%obj.spawnBrick.capForce < 0)
      %obj.spawnBrick.capForce++;
   %obj.decreaseCaptureLoop = schedule(500, 0, decreaseCaptureLoop, %obj);
}
function serverCmdTeams(%cl)
{
   %teamcount[BB_TEAM_RED] = 0;
   %teamcount[BB_TEAM_BLU] = 0;
   %teamcount[BB_TEAM_SPEC] = 0;
   for(%i=0;%i<ClientGroup.getCount();%i++)
   {
      %teamcount[ClientGroup.getObject(%i).bb_team]++;
   }
   messageClient(%cl,'',"\c0RED\c6: "@%teamcount[BB_TEAM_RED]@" players.");
   messageClient(%cl,'',"\c1BLU\c6: "@%teamcount[BB_TEAM_BLU]@" players.");
   messageClient(%cl,'',"\c3Spectators\c6: "@%teamcount[BB_TEAM_SPEC]@" players.");
}