datablock AudioProfile(sentryMinigunSound)
{
   filename    = "./sentry_minigun_loop.wav";
   description = AudioClosest3d;
   preload = true;
};

//LEVEL 1======================================================================
//=============================================================================
//=============================================================================

AddDamageType("SentryGun",   '%1 <bitmap:'@$BB::Path@'scripts/sentry/CI_s_mg1> %1',    '%2 <bitmap:'@$BB::Path@'scripts/sentry/CI_s_mg1> %1',0.75,1);
//projectile
datablock ProjectileData(sentryGunProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 10;
   directDamageType    = $DamageType::SentryGun;
   radiusDamageType    = $DamageType::SentryGun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 60;
   verticalImpulse	  = 40;
   explosion           = gunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 8000;
   fadeDelay           = 6500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Sentry Gun Bullet";
};

//sentry gun datablock (weapon image)
datablock ShapeBaseImageData(sentryGunImage)
{
   shapeFile = "./sentryMG1.1.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
	
   item = gunItem;
   ammo = " ";
   projectile = sentryGunProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   //doColorShift = true;
   //colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 12.0;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSequence[0]	= "Activate";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateWaitForTimeout[1]		= false;
	stateWaitForTimeout[4]		= false;
	stateTimeoutValue[1]             = 2.5;
	stateTransitionOnTimeout[1]       = "Ready2";
	stateSound[1]					= sentryBeepSound;
	stateSequence[1]	= "look1";

	stateName[4]                     = "Ready2";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateAllowImageChange[4]         = true;
	stateTimeoutValue[4]             = 2.5;
	stateTransitionOnTimeout[4]       = "Ready";
	stateSound[4]					= sentryBeepSound;
	stateSequence[4]	= "look2";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.18;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= sentrygunShot1Sound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Alerted";

	stateName[5] = "Alerted";
	stateTransitionOnTriggerDown[5]  = "Fire";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]            = 2.5;
	stateTransitionOnTimeout[5]     = "Ready";
};

function sentryGunImage::onFire(%this, %obj, %slot)
{
	%projectile = %this.projectile;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj.client.player;
		sourceSlot = %slot;
		client = %obj.sentryOwner;
	};
	MissionCleanup.add(%p);
	return %p;
}

//LEVEL 2======================================================================
//=============================================================================
//=============================================================================

AddDamageType("SentryGun2",   '%1 <bitmap:'@$BB::Path@'scripts/sentry/CI_s_mg2> %1',    '%2 <bitmap:'@$BB::Path@'scripts/sentry/CI_s_mg2> %1',0.75,1);
//projectile
datablock ProjectileData(sentryMachineGunProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::SentryGun2;
   radiusDamageType    = $DamageType::SentryGun2;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 20;
   verticalImpulse	  = 10;
   explosion           = gunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 8000;
   fadeDelay           = 6500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Sentry MG Bullet";
};

datablock ShapeBaseImageData(sentryMachineGunImage)
{
   shapeFile = "./sentryMG2.1.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
	
   item = gunItem;
   ammo = " ";
   projectile = sentryMachineGunProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   //doColorShift = true;
   //colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.75;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSequence[0]	= "Activate";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateWaitForTimeout[1]		= false;
	stateWaitForTimeout[4]		= false;
	stateTimeoutValue[1]             = 2.5;
	stateTransitionOnTimeout[1]       = "Ready2";
	stateSound[1]					= sentryBeepSound;
	stateSequence[1]	= "look1";

	stateName[4]                     = "Ready2";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateAllowImageChange[4]         = true;
	stateTimeoutValue[4]             = 2.5;
	stateTransitionOnTimeout[4]       = "Ready";
	stateSound[4]					= sentryBeepSound;
	stateSequence[4]	= "look2";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.12;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= sentrygunShot1Sound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Alerted";

	stateName[5] = "Alerted";
	stateTransitionOnTriggerDown[5]  = "Fire";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]            = 2.5;
	stateTransitionOnTimeout[5]     = "Ready";
};

function sentryMachineGunImage::onFire(%this, %obj, %slot)
{
	%projectile = %this.projectile;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj.client.player;
		sourceSlot = %slot;
		client = %obj.sentryOwner;
	};
	MissionCleanup.add(%p);
	return %p;
}

//LEVEL 3======================================================================
//=============================================================================
//=============================================================================

AddDamageType("SentryGun3",   '%1 <bitmap:'@$BB::Path@'scripts/sentry/CI_s_mg3> %1',    '%2 <bitmap:'@$BB::Path@'scripts/sentry/CI_s_mg3> %1',0.75,1);
//projectile
datablock ProjectileData(sentryMiniGunProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 12;
   directDamageType    = $DamageType::SentryGun3;
   radiusDamageType    = $DamageType::SentryGun3;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 10;
   verticalImpulse	  = 10;
   explosion           = gunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 8000;
   fadeDelay           = 6500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Sentry Minigun Bullet";
};

datablock ShapeBaseImageData(sentryMiniGunImage)
{
   shapeFile = "./sentryMinigun.1.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
	
   item = gunItem;
   ammo = " ";
   projectile = sentryMiniGunProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   //doColorShift = true;
   //colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.75;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSequence[0]	= "Activate";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateWaitForTimeout[1]		= false;
	stateWaitForTimeout[4]		= false;
	stateAllowImageChange[1]         = true;
	stateTimeoutValue[1]             = 2.5;
	stateTransitionOnTimeout[1]       = "Ready2";
	stateSound[1]					= sentryBeepSound;
	stateSequence[1]	= "look1";

	stateName[4]                     = "Ready2";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateAllowImageChange[4]         = true;
	stateTimeoutValue[4]             = 2.5;
	stateTransitionOnTimeout[4]       = "Ready";
	stateSound[4]					= sentryBeepSound;
	stateSequence[4]	= "look2";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.06;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]	= "fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= sentrygunShot1Sound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Alerted";

	stateName[5] = "Alerted";
	stateTransitionOnTriggerDown[5]  = "Fire";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]            = 2.5;
	stateTransitionOnTimeout[5]     = "Ready";
};

function sentryMiniGunImage::onFire(%this, %obj, %slot)
{
	%projectile = %this.projectile;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj.client.player;
		sourceSlot = %slot;
		client = %obj.sentryOwner;
	};
	MissionCleanup.add(%p);
	return %p;
}
