datablock AudioProfile(sentryBuildSound)
{
   filename    = "./sentryBuild.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ItemData(PlaceSentryItem)
{
	category = "Item";  // Mission editor category
	
	shapeFile = "./sentryToolkitMG.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Toolkit - MG";
	iconName = "./icon_sentry_mg";
	doColorShift = false;
	colorShiftColor = "0.200 0.200 0.200 1.000";
	
	image = PlaceSentryImage;
	canDrop = true;
};

datablock ShapeBaseImageData(PlaceSentryImage)
{
   // Basic Item properties
   shapeFile = "./sentryToolkitMG.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0.2";
   rotation = eulerToMatrix("0 0 0");
   eyeOffset = "0.005 1.1 -0.65";
   eyeRotation = eulerToMatrix("-8 4 4");

   //doColorShift = true;
	 //colorShiftColor = PlaceSentryItem.colorShiftColor;
	 
   correctMuzzleVector = false;
   className = "ToolImage";
	 
   item = PlaceSentryItem;

   //melee particles shoot from eye node for consistancy
   melee = true;
   //raise your arm up or not
   armReady = false;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateScript[0]                  = "onActivate";
	stateSequence[0]                  = "Activate";

	stateName[1]                     = "Ready";
	stateScript[1]                  = "onUse";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateScript[2]                  = "onFire";

	minShotTime = 20000;
};

function PlaceSentryImage::onMount(%this, %obj, %slot)
{
	%obj.playthread(1, armReadyBoth);
}

function PlaceSentryImage::onUnMount(%this,%obj,%slot)
{
   %obj.playThread(0, root);
}

function PlaceSentryImage::onActivate(%this, %obj, %slot)
{
	%obj.playthread(1, armReadyBoth);
	%obj.lastcrateslot = %obj.currTool;
}

function PlaceSentryImage::onFire(%this, %obj, %slot)
{
   if(%obj.client.bb_screws < 130)
   {
      commandToClient(%obj.client,'centerPrint',"\c6Sentries require atleast \c3130 \c6metal.",2);
      return;
   }
	createSentryAtPlayer(%obj.client.player);

	%obj.lastFireTime = getSimTime();
	serverCmdUnUseTool(%obj.client);
	%obj.playThread(1, plant);
	%obj.playThread(2, activate2);

  %fvec = %obj.getForwardVector();
  %fX = getWord(%fvec,0);
  %fY = getWord(%fvec,1);
  
  %evec = %obj.getEyeVector();
  %eX = getWord(%evec,0);
  %eY = getWord(%evec,1);
  %eZ = getWord(%evec,2);
  
  %eXY = mSqrt(%eX*%eX+%eY*%eY);
  
  %aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;

	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%aimVec,"-8")));

  serverPlay3D(sentryBuildSound, %obj.getPosition());
  %obj.client.bb_screws=%obj.client.bb_screws-130;
}
