//damage type
AddDamageType("SentryGun",   '%1 <bitmap:'@$BB::Path@'scripts/sentry/CI2> %1',    '%2 <bitmap:'@$BB::Path@'scripts/sentry/CI2> %1',0.75,1);

//audio
datablock AudioProfile(sentrygunShot1Sound)
{
   filename    = "./sentrygunfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(sentryAlertSound)
{
   filename    = "./sentryAlert.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(sentryBeepSound)
{
   filename    = "./sentryloop.wav";
   description = AudioClose3d;
   preload = true;
};

$sentryTypeMasks = $TypeMasks::PlayerObjectType;

//todo - before I forget (which I will)
//make top and bottom die together (onDeath or onRemove, whatever)
//add a death animation to each perhaps
//add custom collisions for both top and bottom (maybe?)
//on sentry death - tell creator their sentry is DOWN OH NO

//prefs
$sentryLoopTime = 100; 																								//time between bullets and target switching, etc
$sentryTargetLength = 90; 																								//how far away target can be

$sentryAimOffset = "0 0 0.71"; 																							//modifier to where to aim at player (a little bit higher than default)
$sentryAimOffsetCrouched = "0 0 -0.5";
//modifer to where to aim at player if he's crouching (a little lower)
$sentryRaycastMasks = $TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType; //masks for player raycast

$sentryOnePerPlayer = 1; 																								//each player can only place one sentry?

$sentryAnnounceToMinigame = 1; 																							//announce to everyone when a player's sentry dies?
$sentryWelderUpgradeRate = 2; 													

//rate at which sentry gains upgrade points (per hit)

//$sentryImage_[KITNAME]_[LEVEL]
$sentryImage_Default_1 = "sentryGunImage";
$sentryImage_Default_2 = "sentryMachineGunImage";
$sentryImage_Default_3 = "sentryMinigunImage";

//$sentryUpgradeThreshold_[KITNAME]_[LEVEL]
//note: sentry XP is reset on each level-up
$sentryUpgradeThreshold_Default_2 = 200;
$sentryUpgradeThreshold_Default_3 = 200;

$sentryTypeMasks = $TypeMasks::PlayerObjectType;

//exec gun and gravity rocket because it's used in some stuff
if(!isObject(gunImage))
{
	exec("add-ons/weapon_gun/server.cs");
	gunItem.uiName = "";
}

if(!isObject(gravityRocketExplosion))
{
	exec("add-ons/Projectile_GravityRocket/server.cs");
	gravityRocketProjectile.uiName = "";
}

//exec the item and upgrade welder

exec("./sentryItem.cs");
//exec("./sentryItemRifle.cs");
//exec("./sentryItemRocket.cs");

//exec("./sentryRifleImages.cs");
//exec("./sentryRocketImages.cs");

exec("./sentryWelder.cs");
exec("./sentryExplosions.cs");
exec("./sentryImages.cs");
exec("./sentryWrangler.cs");

//animations that are really just root
datablock TSShapeConstructor(SentryBottomDts)
{
	baseShape  = "./sentryBottom.dts";
	sequence0  = "./sentry_root.dsq root";
	sequence1  = "./sentry_root.dsq run";
	sequence2  = "./sentry_root.dsq walk";
	sequence3  = "./sentry_root.dsq back";
	sequence4  = "./sentry_root.dsq side";
	sequence5  = "./sentry_root.dsq crouch";
	sequence6  = "./sentry_root.dsq crouchRun";
	sequence7  = "./sentry_root.dsq crouchBack";
	sequence8  = "./sentry_root.dsq crouchSide";
	sequence9  = "./sentry_root.dsq look";
	sequence10 = "./sentry_root.dsq headside";
	sequence11 = "./sentry_root.dsq headUp";
	sequence12 = "./sentry_root.dsq jump";
	sequence13 = "./sentry_root.dsq standjump";
	sequence14 = "./sentry_root.dsq fall";
	sequence15 = "./sentry_root.dsq land";
	sequence16 = "./sentry_root.dsq armAttack";
	sequence17 = "./sentry_root.dsq armReadyLeft";
	sequence18 = "./sentry_root.dsq armReadyRight";
	sequence19 = "./sentry_root.dsq armReadyBoth";
	sequence20 = "./sentry_root.dsq spearready";  
	sequence21 = "./sentry_root.dsq spearThrow";
	sequence22 = "./sentry_root.dsq talk";  
	sequence23 = "./sentry_root.dsq death1"; 
	sequence24 = "./sentry_root.dsq shiftUp";
	sequence25 = "./sentry_root.dsq shiftDown";
	sequence26 = "./sentry_root.dsq shiftAway";
	sequence27 = "./sentry_root.dsq shiftTo";
	sequence28 = "./sentry_root.dsq shiftLeft";
	sequence29 = "./sentry_root.dsq shiftRight";
	sequence30 = "./sentry_root.dsq rotCW";
	sequence31 = "./sentry_root.dsq rotCCW";
	sequence32 = "./sentry_root.dsq undo";
	sequence33 = "./sentry_root.dsq plant";
	sequence34 = "./sentry_root.dsq sit";
	sequence35 = "./sentry_root.dsq wrench";
  sequence36 = "./sentry_root.dsq activate";
  sequence37 = "./sentry_root.dsq activate2";
  sequence38 = "./sentry_root.dsq leftrecoil";
};    

datablock TSShapeConstructor(SentryTopDts)
{
	baseShape  = "./sentryTop.dts";
	sequence0  = "./empty_root.dsq root";
	sequence1  = "./empty_root.dsq run";
	sequence2  = "./empty_root.dsq walk";
	sequence3  = "./empty_root.dsq back";
	sequence4  = "./empty_root.dsq side";
	sequence5  = "./empty_root.dsq crouch";
	sequence6  = "./empty_root.dsq crouchRun";
	sequence7  = "./empty_root.dsq crouchBack";
	sequence8  = "./empty_root.dsq crouchSide";
	sequence9  = "./empty_look.dsq look";
	sequence10 = "./empty_root.dsq headside";
	sequence11 = "./empty_root.dsq headUp";
	sequence12 = "./empty_root.dsq jump";
	sequence13 = "./empty_root.dsq standjump";
	sequence14 = "./empty_root.dsq fall";
	sequence15 = "./empty_root.dsq land";
	sequence16 = "./empty_root.dsq armAttack";
	sequence17 = "./empty_root.dsq armReadyLeft";
	sequence18 = "./empty_root.dsq armReadyRight";
	sequence19 = "./empty_root.dsq armReadyBoth";
	sequence20 = "./empty_root.dsq spearready";  
	sequence21 = "./empty_root.dsq spearThrow";
	sequence22 = "./empty_root.dsq talk";  
	sequence23 = "./empty_root.dsq death1"; 
	sequence24 = "./empty_root.dsq shiftUp";
	sequence25 = "./empty_root.dsq shiftDown";
	sequence26 = "./empty_root.dsq shiftAway";
	sequence27 = "./empty_root.dsq shiftTo";
	sequence28 = "./empty_root.dsq shiftLeft";
	sequence29 = "./empty_root.dsq shiftRight";
	sequence30 = "./empty_root.dsq rotCW";
	sequence31 = "./empty_root.dsq rotCCW";
	sequence32 = "./empty_root.dsq undo";
	sequence33 = "./empty_root.dsq plant";
	sequence34 = "./empty_root.dsq sit";
	sequence35 = "./empty_root.dsq wrench";
  sequence36 = "./empty_root.dsq activate";
  sequence37 = "./empty_root.dsq activate2";
  sequence38 = "./empty_root.dsq leftrecoil";
};

//player datablocks
datablock PlayerData(PlayerSentryBottom : PlayerStandardArmor)
{
	shapeFile = "./sentryBottom.dts";
	
	maxDamage = 150;
	
	boundingBox			= vectorScale("1.075 1.3 2.0", 4); //2.5 2.5 2.4
  crouchBoundingBox	= vectorScale("1.075 1.3 2.0", 4);
  
  thirdPersonOnly = 1;
	
	mass = 470;
	canJet = 0;
	uiName = "";
	maxForwardSpeed = 0;
	maxForwardCrouchSpeed = 0;
	maxBackwardSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxSideSpeed = 0;
	maxSideCrouchSpeed = 0;
	jumpForce = 0;
};

datablock PlayerData(PlayerSentryTop : PlayerSentryBottom)
{
	shapeFile = "./sentryTop.dts";

	cameramaxdist = 4;
	cameraVerticalOffset = 0.6;
	cameraTilt = 0.0;
};

if(!isObject(sentryGroup))
{
	new simGroup(sentryGroup);
}

package SentryPackage {
	function MiniGameSO::reset(%this, %client)
	{
		for(%i = 0; %i < sentryGroup.getCount(); %i++)
		{
			%sentry = sentryGroup.getObject(%i);
			if(%sentry.sentryOwner.minigame == %this)
				%sentry.kill();
		}
		parent::reset(%this, %client);
	}
	
	function miniGameSO::removeMember(%this, %member)
	{
		for(%i = 0; %i < sentryGroup.getCount(); %i++)
		{
			%sentry = sentryGroup.getObject(%i);
			if(%sentry.sentryOwner == %member)
				%sentry.kill();
		}
		parent::removeMember(%this, %member);
	}
};
activatePackage(sentryPackage);

function createSentryAtPlayer(%player)
{
   if(!isObject(sentryGroup)) new SimSet(sentryGroup);
	if($sentryOnePerPlayer)
	{
		for(%i = 0; %i < sentryGroup.getCount(); %i++)
		{
			if(isObject(sentryGroup.getObject(%i).sentryOwner) && sentryGroup.getObject(%i).sentryOwner == %player.client)
			{
				sentryGroup.getObject(%i).kill();
			}
		}
	}
	%pos = vectorAdd(vectorScale(%player.getForwardVector(), 3) @ " 0 0 0 0", %player.getTransform());
	%bottom = new AIPlayer()
	{
		datablock = "PlayerSentryBottom";
		position = %pos;
		sentryOwner = %player.client;
		tdmTeam = %player.client.tdmTeam;
		sentryKit = "Default";
		sentryXP = 0;
	};
	%top = new AIPlayer()
	{
		datablock = "PlayerSentryTop";
		sentryBottom = %bottom;
		sentryOwner = %player.client;
		tdmTeam = %player.client.tdmTeam;
	};

	%p = new Projectile()
  {
     dataBlock = toolboxExplosionProjectile;
     initialPosition = %pos;
     initialVelocity = "0 0 1";
     client = %obj.client;
     sourceClient = %obj.client;
  };

	%top.client = %top;
	%top.player = %top;
	%top.minigame = %player.client.minigame;
	%top.sentryLevel = 1;
	%top.sentryKit = "Default";
	
	%bottom.client = %bottom;
	%bottom.player = %bottom;
	%bottom.minigame = %player.client.minigame;
	
	%top.hideNode("invisible");

	%bottom.mountObject(%top, 0);
	%top.setControlObject(%top); //must do this or it spins in circles
	
	%bottom.sentryTop = %top;
	%top.sentryBottom = %bottom;
	
	sentryGroup.add(%top);
	
	%top.mountImage($sentryImage_Default_1, 0);
	
	//schedule(12000, 0, "finishSentryBuild", %top);
	
	if(!isEventPending($sentryLogicLoopSched))
		sentryLogicLoop();
}

function finishSentryBuild(%obj)
{
	%obj.isBuilt = 1;
	
	%obj.mountImage($sentryImage_Default_1, 0);

	%pos = %obj.getPosition();
	%p = new Projectile()
  {
     dataBlock = sentryProjectile;
     initialPosition = %pos;
     initialVelocity = "0 0 1";
     client = %obj.client;
     sourceClient = %obj.client;
  };
  MissionCleanup.add(%p);
  %p.explode();

	serverPlay3D(sentryalertsound, %sentry.getPosition());
}

//These stop console spam.
//If you use these in something else, I'm sorry. Comment them out.
function AIPlayer::incScore(%this, %obj)
{
	//do nothing.
}

function AIPlayer::onDeath(%this, %obj, %source)
{
	//do nothing.
}

function playerSentryTop::onDisabled(%this, %obj, %state)
{
	if(isObject(%obj.sentryOwner))
	{
		if($sentryAnnounceToMinigame)
		{
			%obj.sentryOwner.minigame.messageAllExcept(%obj.sentryOwner, "", "\c3" @ %obj.sentryOwner.name @ "'s \c2sentry is \c0DOWN\c2!");
			messageClient(%obj.sentryOwner, "", "\c2Your sentry is \c0DOWN\c2!");
		}else{
			messageClient(%obj.sentryOwner, "", "\c2Your sentry is \c0DOWN\c2!");
		}
	}
	
	%pos = %obj.getPosition();
	%p = new Projectile()
  {
     dataBlock = gravityRocketProjectile;
     initialPosition = %pos;
     initialVelocity = "0 0 1";
     client = %obj.client;
     sourceClient = %obj.client;
  };
  MissionCleanup.add(%p);
  %p.explode();
  
  if(isObject(%obj.sentryBottom))
		%obj.sentryBottom.schedule(10, delete);
  
  %obj.schedule(10,"delete");

	if(%obj.getControllingClient())
		%obj.getControllingClient().setControlObject(%obj.getControllingClient().player);
}

function playerSentryBottom::onDisabled(%this, %obj, %state)
{
	%pos = %obj.getPosition();
	%p = new Projectile()
  {
     dataBlock = gravityRocketProjectile;
     initialPosition = %pos;
     initialVelocity = "0 0 1";
     client = %obj.client;
     sourceClient = %obj.client;
  };
  MissionCleanup.add(%p);
  %p.explode();
  
  if(isObject(%obj.sentryTop))
		%obj.sentryTop.schedule(10, delete);
  
  %obj.schedule(10,"delete");
}

function serverCmdSentryTest(%client)
{
	if(%client.isAdmin || %client.isSuperAdmin)
		createSentryAtPlayer(%client.player);
}

function sentryLogicLoop()
{
   if(!isObject(sentryGroup))
   {
      new SimGroup(sentryGroup);
   }
	for(%i = 0; %i < sentryGroup.getCount(); %i++)
	{
		%sentry = sentryGroup.getObject(%i);
		if(!isObject(%sentry.sentryOwner))
			%sentry.kill();
		if(isObject(%sentry.sentryOwner.minigame) && %sentry.getState() !$= "Dead")
		{
			if(!isObject(%sentry.target) || %sentry.target.getState() $= "Dead" || vectorLen(vectorSub(%sentry.target.getPosition(), %sentry.getPosition())) > $sentryTargetLength || ContainerRayCast(%sentry.getPosition(), %sentry.target.getPosition(), $sentryRaycastMasks) != 0)
			{
				%sentry.target = "";
				//acquire target
				%len = $sentryTargetLength + 1;
				for(%c = 0; %c < clientGroup.getCount(); %c++)
				{
					%player = clientGroup.getObject(%c).player;
					if(isObject(%player) && %sentry.sentryOwner.bb_team !$= %player.client.bb_team && %player != %sentry.sentryOwner.player && %player.isCloaked != 1 && %player.isDisguised != 1)
					{
						%checkLen = vectorLen(vectorSub(%player.getPosition(), %sentry.getPosition()));
						if(%checkLen < %len)
						{
							if(ContainerRayCast(%sentry.getPosition(), %player.getPosition(), $sentryRaycastMasks) == 0)
							{
								//found new target
								%sentry.target = %player;
								%len = %checkLen;
								%targetAcquired = 1;
							}
						}
					}
				}
				if(%targetAcquired)
				{
					//play sentry beep sound
					serverPlay3D(sentryalertsound, %sentry.getPosition());
				}
			}
			
			//if you have a target, shoot at it
			if(isObject(%sentry.target) && %sentry.target.getState() !$= "Dead" && %sentry.getState() !$= "Dead")
			{
				//aim
				if(%sentry.target.isCrouched())
					%sentry.setAimLocation(vectorAdd(%sentry.target.getPosition(), $sentryAimOffsetCrouched));
				else
					%sentry.setAimLocation(vectorAdd(%sentry.target.getPosition(), $sentryAimOffset));
				//shoot
				%sentry.setImageTrigger(0, 1);
				%sentry.setImageTrigger(0, 0);
			}
		}
	}
	
	if(sentryGroup.getCount() > 0)
		$sentryLogicLoopSched = schedule($sentryLoopTime, 0, "sentryLogicLoop");
}

function serverCmdClearSentries(%client)
{
	if(%client.isAdmin || %client.isSuperAdmin)
	{
		messageAll("", "\c2" @ %client.name @ " \c3cleared all sentries.");
		for(%i = 0; %i < sentryGroup.getCount(); %i++)
		{
			sentryGroup.getObject(%i).sentryBottom.schedule(10, "delete");
			sentryGroup.getObject(%i).schedule(10, "delete");
		}
	}
}

function sentryChangeKit(%obj, %kit)
{
if($sentryImage_[%kit @ "_1"] $= "")
return;

%obj.sentryXP = 0;
%obj.sentryLevel = 1;
%obj.sentryKit = %kit;
%obj.unMountImage(0);
%obj.mountImage($sentryImage_[%kit @ "_1"], 0);
}

//put this in the package
function playerSentryTop::onTrigger(%this, %obj, %slot, %val)
{
	%client = %obj.getControllingClient();
	if(%val && %slot == 4 && %client.player != %obj)
	{
		%client.setControlObject(%client.player);
		return;
	}
	parent::onTrigger(%this, %obj, %slot, %val);
}