datablock AudioProfile(TF2MedigunActivateSound)
{
   filename    = $BB::Path @ "data/medigunActivate.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock ParticleData(TF2MedigunHealParticleA)
{
	textureName          = "base/data/particles/dot";
	dragCoefficient      = 10.0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.0;
	windCoefficient      = 0;
	constantAcceleration = 0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 0;
	spinSpeed     = 0;
	spinRandomMin = 0.0;
	spinRandomMax = 0.0;
	useInvAlpha   = false;

	colors[0]	= "0.9 0.0 0.0 0.0";
	colors[1]	= "0.9 0.2 0.1 0.3";
	colors[2]	= "0.9 0.2 0.1 0.3";
	colors[3]	= "0.9 0.0 0.0 0.0";

	sizes[0]	= 0.2;
	sizes[1]	= 0.4;
	sizes[2]	= 0.4;
	sizes[3]	= 0.4;

	times[0]	= 0.0;
	times[1]	= 0.3;
	times[2]	= 0.7;
	times[3]	= 1.0;
};

datablock ParticleEmitterData(TF2MedigunHealEmitterA)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   ejectionOffset   = 0.0;
   velocityVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 0;
   overrideAdvance = false;
   particles = TF2MedigunHealParticleA;   
   
   useEmitterColors = true;
   
   uiName = "Medigun Heal A";
};

datablock ParticleData(TF2MedigunHealParticleB)
{
   dragCoefficient      = 6.0;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = true;
   textureName          = $BB::Path @ "data/heal_white";
   colors[0]     = "0.9 0.0 0.0 1.0";
   colors[1]     = "0.9 0.3 0.3 1.0";
   colors[2]     = "0.9 0.0 0.0 0.0";
   sizes[0]      = 0.3;
   sizes[1]      = 0.3;
   sizes[2]      = 0.2;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(TF2MedigunHealEmitterB)
{
   ejectionPeriodMS = 60;
   periodVarianceMS = 30;
   ejectionVelocity = 0.6;
   ejectionOffset   = 0.4;
   velocityVariance = 0.3;
   thetaMin         = 0;
   thetaMax         = 120;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TF2MedigunHealParticleB";

   uiName = "Medigun Heal B";
};

datablock ProjectileData(TF2MedigunHealProjectileA)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   explosion           = "";
   particleEmitter     = Tf2MedigunHealEmitterA;
   explodeOnDeath = false;

   brickExplosionRadius = 0;
   brickExplosionImpact = 0;             //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   collideWithPlayers = true;

   sound = "";

   muzzleVelocity      = 16;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 625;
   fadeDelay           = 490;
   bounceElasticity    = 0.99;
   bounceFriction      = 0.00;
   isBallistic         = true;
   gravityMod          = 0.0;

   hasLight    = false;
   lightRadius = 1.0;
   lightColor  = "1.0 1.0 0.5";

   uiName = "Medigun Beam A"; 
};

datablock ProjectileData(TF2MedigunHealProjectileB)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   explosion           = "";
   particleEmitter     = Tf2MedigunHealEmitterB;
   explodeOnDeath = false;

   brickExplosionRadius = 0;
   brickExplosionImpact = 0;             //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   collideWithPlayers = true;

   sound = "";

   muzzleVelocity      = 16;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 625;
   fadeDelay           = 490;
   bounceElasticity    = 0.99;
   bounceFriction      = 0.00;
   isBallistic         = true;
   gravityMod          = 0.0;

   hasLight    = false;
   lightRadius = 1.0;
   lightColor  = "1.0 1.0 0.5";

   uiName = "Medigun Beam B"; 
};

datablock ParticleData(PlayerTF2HealParticle : PlayerTeleportParticleB)
{
	textureName = $BB::Path @ "data/heal_white";
	
	colors[0]     = "0.9 0.0 0.0 1.0";
	colors[1]     = "0.9 0.3 0.3 1.0";
	colors[2]     = "0.9 0.0 0.0 0.0";
	
	lifetimems = 750;
	lifetimevariancems = 250;	
};

function doHealBeam(%obj,%target)
{
   %start = vectorAdd(%obj.getPosition(),"0 0" SPC (getWord(%obj.getDataBlock().boundingBox,2) / 6.5));
   %end = vectorAdd(%target.getPosition(),"0 0" SPC (getWord(%target.getDataBlock().boundingBox,2) / 6.5));
	%pos = %end;
	%dir = vectorNormalize(vectorSub(%pos,%start));
	%projectile = TF2MedigunHealProjectileA;
	
	for(%i=0;%i<3;%i++)
	{
		%t = vectorDist(%start,%end) / vectorLen(vectorScale(getWord(%dir,0) SPC getWord(%dir,1),%projectile.muzzleVelocity));
		%end = vectorAdd(%pos,vectorScale(%target.getVelocity(),%t));
		%dir = vectorNormalize(vectorSub(%end,%start));
	}
	
	%scaleFactor = getWord(%obj.getScale(),2);
	
	%p = new Projectile()
	{
		dataBlock = TF2MedigunHealProjectileA;
		initialPosition = %start;
		initialVelocity = vectorScale(%dir,%projectile.muzzleVelocity);
		sourceObject = %obj;
		client = %obj.client;
		sourceClient = %obj.client;
		sourceSlot = %slot;
		originPoint = %start;
	};
	MissionCleanup.add(%p);
	%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
	
	if(getSimTime() - %obj.lastHealEmitTime[%target] > 200)
	{
		%obj.lastHealEmitTime[%target] = getSimTime();
		%p2 = new Projectile()
		{
			dataBlock = TF2MedigunHealProjectileB;
			initialPosition = %start;
			initialVelocity = vectorScale(%dir,%projectile.muzzleVelocity);
			sourceObject = %obj;
			client = %obj.client;
			sourceClient = %obj.client;
			sourceSlot = %slot;
			originPoint = %start;
		};
		MissionCleanup.add(%p);
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
	}
}