package BB_support_showBuilding
{
   function GameConnection::onClientEnterGame(%this)
   {
      %this.schedule(250,showBuildingTypePrint);
      Parent::onClientEnterGame(%this);
   }
};
activatePackage(BB_support_showBuilding);

function raycastObj(%cl)
{
   if(!isObject(%cl.player)) return 0;
   %l=VectorAdd(%cl.player.getEyePoint(), VectorScale(%cl.player.getEyeVector(),50));
   %r=containerRaycast(%cl.player.getEyePoint(), %l, $TypeMasks::All, %cl.player);
   if(!isObject(%r)) return 0;
   return %r;
}

function GameConnection::showBuildingTypePrint(%this)
{
   cancel(%this.showtype);
   if(!isObject(%obj = raycastObj(%this)))
   {
      %this.showtype = %this.schedule(150,showBuildingTypePrint);
      return;
   }
   if(strLen(%obj.dataBlock) > 0 && (%obj.dataBlock $= "playerSentryBottom" || %obj.dataBlock $= "playerSentryTop"))
      %type = "sentry";
   else if(%obj.bb_type $= "dispenser")
      %type = "dispenser";
   else if(%obj.bb_type $= "teleporterEntrance")
      %type = "teleIn";
   else if(%obj.bb_type $= "teleporterExit")
      %type = "teleOut";
   else
   {
      %this.showtype = %this.schedule(150,showBuildingTypePrint);
      return;
   }
   switch$ (%type)
   {
      case "dispenser": %type = "Dispenser";
      case "sentry": %type = "Sentry Gun";
      case "teleIn": %type = "Teleporter Entrance";
      case "teleOut": %type = "Teleporter Exit";
      default:
         %this.showtype = %this.schedule(150,showBuildingTypePrint);
         return;
   }
   %font1 = "<font:verdana:18>";
   %font2 = "<font:verdana:16>";
   if(%type $= "Sentry Gun")
      %str = %type SPC "created by" SPC %obj.sentryOwner.name;
   else
      %str = %type SPC "created by" SPC %obj.owner.name;
   if(%type $= "Sentry Gun")
   {
      if(%obj.dataBlock $= "playerSentryTop")
         %obj = %obj.sentryBottom;
      %level = %obj.sentryTop.sentryLevel;
      %upgra = %obj.sentryTop.sentryXP;
   }
   else
   {
      %level = %obj.bb_upgradeLevel;
      %upgra = %obj.bb_screws;
   }
   if(%level < 3)
      %info = "(Level "@%level@") - Upgrade Progress: "@%upgra@"/200";
   else
      %info = "(Level 3)";
   if(getSubStr(%type,0,11) $= "Teleporter ")
      %extra = "Recharging: "@%obj.bb_power@"% - ";
   commandToClient(%this,'centerPrint',%font1 @ "<br><br>\c3" @ %str @ (strLen(%info) > 0 ? %font2 @ %extra @ "<br>\c4" @ %info : ""),0.2);
   %this.showtype = %this.schedule(150,showBuildingTypePrint);
}