package BB_select_team
{
   function serverCmdNextSeat(%cl)
   {
      if($UseNormalNextSeat)
         Parent::serverCmdNextSeat(%cl);
      else
         commandToClient(%cl,'OpenTeamSelection');
   }
};
activatePackage(BB_select_team);

function serverCmdJoinTeam(%cl,%team)
{
   switch$ (%team)
   {
      case RED: %id = 0;
      case BLU: %id = 1;
      case BLUE: %id = 1;
      case Spectators: %id = 2;
      case Spectator: %id = 2;
      case SPEC: %id = 2;
   }
   serverCmdTeam(%cl,%id);
}

function AutoBalanceTeams()
{
   if(ClientGroup.getCount()<=1)
      return;
   $AutoBalancingTeams = true;
   messageall('',"\c6Auto-balancing teams...");
   echo("Auto-balancing teams...");
   %blu = new SimSet(AUTO_BB_TEAM_BLU);
   %red = new SimSet(AUTO_BB_TEAM_RED);
   for(%i=0;%i<ClientGroup.getCount();%i++)
   {
      %fcl = ClientGroup.getObject(%i);
      %team = %fcl.bb_team;
      nametoid("AUTO_"@%team).add(%fcl);
   }
   
   if(strPos(ClientGroup.getCount() / 2,".") < 0)
   {
      if(%blu.getCount() < %red.getCount())
      {
         %diff = %red.getCount() - %blu.getCount() / 2;
         for(%i=0;%i<%diff;%i++)
         {
            %person = getRandom(0,%red.getCount()-1);
            %person = %red.getObject(%person);
            serverCmdTeam(%person,1);
         }
      }
      else if(%blu.getCount() > %red.getCount())
      {
         %diff = %blu.getCount() - %red.getCount() / 2;
         for(%i=0;%i<%diff;%i++)
         {
            %person = getRandom(0,%blu.getCount()-1);
            %person = %blu.getObject(%person);
            serverCmdTeam(%person,0);
         }
      }
   }
   else
   {
      if(%blu.getCount() - %red.getCount() $= 1 || %red.getCount() - %blu.getCount() $= 1)
         return;
      if(%blu.getCount() < %red.getCount())
      {
         %diff = %red.getCount() - %blu.getCount() / 2;
         echo(" + RED has "@%diff@" more people than BLU.");
         // We need to move %diff RED people to BLU.
         for(%i=0;%i<%diff;%i++)
         {
            %person = getRandom(0,%red.getCount()-1);
            %person = %red.getObject(%person);
            serverCmdTeam(%person,1);
         }
      }
      else if(%blu.getCount() > %red.getCount())
      {
         %diff = %blu.getCount() - %red.getCount() / 2;
         echo(" + BLU has "@%diff@" more people than RED.");
         // We need to move %diff BLU people to RED.
         for(%i=0;%i<%diff;%i++)
         {
            %person = getRandom(0,%blu.getCount()-1);
            %person = %blu.getObject(%person);
            serverCmdTeam(%person,0);
         }
      }
   }
   %blu.delete();
   %red.delete();
   $AutoBalancingTeams = false;
}

function serverCmdTeam(%cl,%id)
{
   if($Sim::Time - %cl.lastTeamChange <= 2)
      return;
   %cl.lastTeamChange = $Sim::Time;
   if(!isEventPending($BalanceTeamsSched) && !$AutoBalancingTeams && ClientGroup.getCount()>1)
   {
      for(%i=0;%i<ClientGroup.getCount();%i++)
      {
         %teamcount[ClientGroup.getObject(%i).bb_team]++;
      }
      if(%teamcount[BB_TEAM_RED] $= %teamcount[BB_TEAM_BLU]) //yay
      {
      }
      else
      {
         schedule(200,0,messageAll,'',"\c6Balancing teams in \c330 \c6seconds.");
         $BalanceTeamsSched = schedule(30000,0,AutoBalanceTeams);
      }
   }
   switch (%id)
   {
      case 0: %type = BB_TEAM_RED;
              %ui = "RED";
              %col = "\c0";
      case 1: %type = BB_TEAM_BLU;
              %ui = "BLU";
              %col = "\c1";
      case 2: %type = BB_TEAM_SPEC;
              %ui = "Spectators";
              %col = "\c2";
      default: messageClient(%cl,'',"\c6Invalid team type, please verify you have the latest version of the client.");
               return;
   }
   if(%cl.bb_team $= %type)
      return;
   messageAll('',"\c3"@%cl.name@" \c6has changed team to "@%col@%ui@"\c6.");
   %cl.bb_team = %type;
   %cl.bb_teamui = %ui;
   deleteEngineerBuilding(%cl,"sentry");
   deleteEngineerBuilding(%cl,"dispenser");
   deleteEngineerBuilding(%cl,"teleporterEntrance");
   deleteEngineerBuilding(%cl,"teleporterExit");
   %cl.instantRespawn();
}