function GameConnection::backpackLoad(%this)
{
   %file1 = "config/server/blockbastion/backpack/"@%this.bl_id@".cs";
   %file2 = "config/server/blockbastion/backpack/"@%this.bl_id@".sv";
   if(!isFile(%file1) || !isFile(%file2))
      return 0;
   if(isObject(%bp = nametoid("BB_BACKPACK_DATA_"@%this.bl_id)))
      %bp.delete();
   exec(%file1);
   if(!isObject(%bp = nametoid("BB_BACKPACK_DATA_"@%this.bl_id)))
      return -1;
   %this.backpackData = %bp;
   %fo = new FileObject();
   %fo.openForRead(%file2);
   while(!%fo.isEOF())
   {
      if(!isObject(%item = %fo.readLine()))
         continue;
      %bp.add(%item);
   }
   %fo.close();
   %fo.delete();
   return 1;
}
function GameConnection::backpackSave(%this)
{
   if(isObject(%bp = %this.backpackData))
   {
      %bp.owner = %this.bl_id;
      %bp.name = %this.name;
      %bp.lastSaveTime = getDateTime();
      eval("$tmp["@%this.bl_id@"] = new ScriptGroup("@%bp.getName()@" : "@%bp.getName()@");");
      %tmp = $tmp[%this.bl_id];
      %tmp.save("config/server/blockbastion/backpack/"@%this.bl_id@".cs");
      %tmp.delete();
   }
   else
      return -1;
   %fo = new FileObject();
   %fo.openForWrite("config/server/blockbastion/backpack/"@%this.bl_id@".sv");
   for(%i=0;%i<%bp.getCount();%i++)
   {
      %obj = %bp.getObject(%i);
      if(strLen(%obj.getName()) > 0)
         %fo.writeLine(%obj.getName());
      else
         %fo.writeLine(%obj);
   }
   %fo.close();
   %fo.delete();
   return 1;
}
function GameConnection::backpackMount(%this,%class,%slot,%item)
{
   %minSlot = 0;
   switch$ (%class)
   {
      case scout: %maxSlot = 2;
      case soldier: %maxSlot = 2;
      case pyro: %maxSlot = 2;
      case demoman: %maxSlot = 2;
      case heavy: %maxSlot = 2;
      case engineer: %maxSlot = 4;
      case medic: %maxSlot = 2;
      case sniper: %maxSlot = 2;
      case spy: %maxSlot = 4;
      default: return -1;
   }
   if(%slot < %minSlot || %slot > %maxSlot)
      return -2;
   if(!isObject(%item))
      return -3;
   if(!isObject(%bp = %this.backpackData))
      return -4;
   if(!%bp.isMember(%item))
      return -5;
   %bp.item[%class,%slot] = %item;
   %this.backpackSave();
   return 0;
}
function GameConnection::backpackAdd(%this,%item)
{
   if(!isObject(%bp = %this.backpackData))
      return -2;
   if(!isObject(%item))
      return -1;
   %bp.add(%item);
   %this.backpackSave();
   return 0;
}
function GameConnection::backpackInit(%this)
{
   if(!isObject(BB_BACKPACK_DATA_STOCK))
   {
      exec("config/server/blockbastion/backpack/_STOCK.cs");
      %name = "BB_BACKPACK_DATA_"@%this.bl_id;
      %this.backpackData = new ScriptGroup(%name : BB_BACKPACK_DATA_STOCK) { owner = %this.bl_id; name = %this.name; lastSaveTime = getDateTime(); };
      %fo = new FileObject();
      %fo.openForRead("config/server/blockbastion/backpack/_STOCK.sv");
      while(!%fo.isEOF())
      {
         %item = %fo.readLine();
         if(!isObject(%item))
            continue;
         BB_BACKPACK_DATA_STOCK.add(%item);
         %this.backpackData.add(%item);
      }
      %fo.close();
      %fo.delete();
   }
   else
   {
      %name = "BB_BACKPACK_DATA_"@%this.bl_id;
      %this.backpackData = new ScriptGroup(%name : BB_BACKPACK_DATA_STOCK) { owner = %this.bl_id; name = %this.name; lastSaveTime = getDateTime(); };
      for(%i=0;%i<BB_BACKPACK_DATA_STOCK.getCount();%i++)
      {
         %obj = BB_BACKPACK_DATA_STOCK.getObject(%i);
         %this.backpackData.add(%obj);
      }
   }
   %this.backpackSave();
}