function changeBastionMap(%map)
{
   %filen = %map @ ".mis";
   %exists = 0;
   for(%file=findFirstFile("Add-Ons/Map_*/" @ %filen);%file!$="";%file=findNextFile("Add-Ons/Map_*/" @ %filen))
   {
      %n = fileName(%file);
      if(strLwr(%n) $= strLwr(%filen) && isFile(filePath(%file) @ "/bastion.cs"))
      {
         %exists = 1;
         %realn = fileBase(%file);
         %realF = %file;
         %bastion = filePath(%file) @ "/bastion.cs";
      }
   }
   if(!%exists)
   {
      echo("Invalid BastionMap: " @ %map);
      return;
   }
   $ChangingToBastionMap = %realF;
   changeMap(%realn);
}

function finishBastionMapLoad(%map)
{
   for(%file=findFirstFile("Add-Ons/Map_*/" @ %map @ ".mis");%file!$="";%file=findNextFile("Add-Ons/Map_*/" @ %map @ ".mis"))
   {
      if(fileBase(%file) $= %map)
      {
         %exists = 1;
         %map = %file;
      }
   }
   if(!%exists)
      return;
   %path = filePath(%map) @ "/" @ fileBase(%map) @ ".bls";
	fileCopy(%path, "base/server/temp/temp.bls");
   %client = new AIConnection()
   {
      name = "Block Bastion";
      bl_id = 12;
      isAdmin = 1;
   };
   if(!isObject(BrickGroup_12))
   {
      new SimGroup(BrickGroup_12)
      {
         name = "Block Bastion";
         bl_id = 12;
         client = %client;
      };
      MainBrickGroup.add(BrickGroup_12);
   }
   %client.brickGroup = BrickGroup_12;
   MainBrickGroup.add(BrickGroup_12);
	serverCmdReloadBricks(%client);
	schedule(100,%client,delete);
   exec(filePath(%map) @ "/bastion.cs");
   startMapRound();
}

function startMapRound()
{
   %gm = MissionInfo.gamemode;
   %time = getSubStr(MissionIdnfo.roundTime,0,strPos(MissionInfo.roundTime,":"))*60+getSubStr(MissionInfo.roundTime,strPos(MissionInfo.roundTime,":")+1,strLen(MissionInfo.roundTime));
   if(strLen($JustLoadLoopDat) > 0)
      startRound(%gm,%time,YES,true,$JustLoadLoopDat);
   else
      startRound(%gm,%time,YES,false);
}

function startRound(%gamemode,%min,%sec,%loop,%loops)
{
   switch$ (%gamemode)
   {
      case ctf:
      case cp:
      case koth:
      case pl:
      case tr:
      case arena:
      default:
         announce("startRound("@%gamemode@","@%min@","@%sec@") - invalid gamemode.");
         return;
   }
   if(%sec $= YES)
      %time = %min;
   else
      %time = %min*60+%sec;
   $RoundStartTime = $Sim::Time;
   $RoundTime = %time;
   $RoundRunning = true;
   $RoundLooping = %loop;
   $RoundLoopAmnt = %loops;
   $RoundGamemode = strupr(%gamemode);
   if(isFunction("startGamemodeRound_" @ $RoundGamemode))
       call("startGamemodeRound_" @ $RoundGamemode,%time);
   schedule(1000,0,roundTickCheck);
}

function getRoundTime()
{
   return $RoundTime - mFloor($Sim::Time - $RoundStartTime);
}

function roundTickCheck()
{
   cancel($RoundTick);
   if(!$RoundRunning)
      return;
   %roundTime = getRoundTime();
   if(getRoundTime() < 1)
   {
      if(isFunction("endGamemodeRound_" @ $RoundGamemode))
         call("endGamemodeRound_" @ $RoundGamemode);
      onEndRound();
      return;
   }
   if(%roundTime $= 1)
   {
      teamPlaySound("tf2_mission_timeleft_1sec",BB_TEAM_RED);
      teamPlaySound("tf2_mission_timeleft_1sec",BB_TEAM_BLU);
   }
   if(%roundTime $= 2)
   {
      teamPlaySound("tf2_mission_timeleft_2sec",BB_TEAM_RED);
      teamPlaySound("tf2_mission_timeleft_2sec",BB_TEAM_BLU);
   }
   if(%roundTime $= 3)
   {
      teamPlaySound("tf2_mission_timeleft_3sec",BB_TEAM_RED);
      teamPlaySound("tf2_mission_timeleft_3sec",BB_TEAM_BLU);
   }
   if(%roundTime $= 4)
   {
      teamPlaySound("tf2_mission_timeleft_4sec",BB_TEAM_RED);
      teamPlaySound("tf2_mission_timeleft_4sec",BB_TEAM_BLU);
   }
   if(%roundTime $= 5)
   {
      teamPlaySound("tf2_mission_timeleft_5sec",BB_TEAM_RED);
      teamPlaySound("tf2_mission_timeleft_5sec",BB_TEAM_BLU);
   }
   if(%roundTime $= 10)
   {
      teamPlaySound("tf2_mission_timeleft_10sec",BB_TEAM_RED);
      teamPlaySound("tf2_mission_timeleft_10sec",BB_TEAM_BLU);
   }
   if(%roundTime $= 60)
   {
      teamPlaySound("tf2_mission_timeleft_1min",BB_TEAM_RED);
      teamPlaySound("tf2_mission_timeleft_1min",BB_TEAM_BLU);
   }
   if(%roundTime $= 300)
   {
      teamPlaySound("tf2_mission_timeleft_5min",BB_TEAM_RED);
      teamPlaySound("tf2_mission_timeleft_5min",BB_TEAM_BLU);
   }
   $RoundTick = schedule(1000,0,roundTickCheck);
}

function onEndRound()
{
   switch$ ($RoundGamemode)
   {
      case PL:
         winRoundForTeam(BB_TEAM_BLU,"defended until time ran out");
         return;
      case CP:
         switch$ (MissionInfo.cp_type)
         {
            case "defensive":
               winRoundForTeam(BB_TEAM_BLU,"defended until time ran out");
               return;
            case "mixed":
               if(isFunction("getMixedWinner_CP"))
               {
                  %output = call("getMixedWinner_CP");
                  winRoundForTeam(firstWord(%output),restWords(%output));
               }
               return;
            default:
               if(isFunction("getMixedWinner_CP"))
               {
                  %output = call("getMixedWinner_CP");
                  winRoundForTeam(firstWord(%output),restWords(%output));
               }
               return;
         }
   }
   %points[BB_TEAM_RED] = 0;
   %points[BB_TEAM_BLU] = 0;
   for(%i=0;%i<ClientGroup.getCount();%i++)
   {
      %points[ClientGroup.getObject(%i).bb_team] = %points[ClientObject.getObject(%i).bb_team] + ClientGroup.getObject(%i).score;
   }
   if(%points[BB_TEAM_RED] $= %points[BB_TEAM_BLU])
      %winTeam = NONE;
   else if(%points[BB_TEAM_RED] > %points[BB_TEAM_BLU])
      %winTeam = BB_TEAM_RED;
   else if(%points[BB_TEAM_BLU] > %points[BB_TEAM_RED])
      %winTeam = BB_TEAM_BLU;
   winRoundForTeam(%winTeam,"had higher total score at end of round");
}
function MinigameSO::doMinigameReset(%this)
{
   for(%i=0;%i<%this.numMembers;%i++)
   {
      %cl = %this.member[%i];
      if(isObject(%cl))
         %cl.setScore(0);
   }
   %this.RespawnAll();
}
function winRoundForTeam(%winTeam,%reason)
{
   if($RoundLooping)
   {
      %a = $RoundLoopAmnt;
      if(%a $= 0 && !$MapRotationDisabled)
      {
         %lastRound = 1;
      }
   }
   if(%winTeam $= NONE)
   {
      messageAll('',"\c6STALEMATE! You're all losers! (no team managed to win this round)");
      teamPlaySound("tf2_mission_end_stalemate",BB_TEAM_RED);
      teamPlaySound("tf2_mission_end_stalemate",BB_TEAM_BLU);
      $RoundRunning = false;
      if(isObject($BB::Minigame))
         $BB::Minigame.schedule(15000,doMinigameReset);
      schedule(15000,0,eval,%cap @ ".capForce = 0;");
      schedule(15000,0,eval,%cap @ ".capTeam = NONE;");
      if(isObject(%cap))
         %cap.schedule(15000,setColor,16);
      if(%lastRound)
      {
         schedule(15000,nextMapRotate);
         return;
      }
      if($RoundLooping && !%lastRound)
         schedule(15000,0,startRound,$RoundGamemode,$RoundTime,YES,$RoundLooping,$RoundLoopAmnt--);
   }
   else if(%winTeam $= BB_TEAM_RED)
   {
      messageAll('',"\c0RED \c6team won this round! ("@%reason@")");
      teamPlaySound("tf2_mission_end_won",BB_TEAM_RED);
      teamPlaySound("tf2_mission_end_lost",BB_TEAM_BLU);
      $RoundRunning = false;
      if(isObject($BB::Minigame))
         $BB::Minigame.schedule(15000,doMinigameReset);
      schedule(15000,0,eval,%cap @ ".capForce = 0;");
      schedule(15000,0,eval,%cap @ ".capTeam = NONE;");
      if(isObject(%cap))
         %cap.schedule(15000,setColor,16);
      if(%lastRound)
      {
         schedule(15000,nextMapRotate);
         return;
      }
      if($RoundLooping && !%lastRound)
         schedule(15000,0,startRound,$RoundGamemode,$RoundTime,YES,$RoundLooping,$RoundLoopAmnt--);
   }
   else if(%winTeam $= BB_TEAM_BLU)
   {
      messageAll('',"\c1BLU \c6team won this round! ("@%reason@")");
      teamPlaySound("tf2_mission_end_won",BB_TEAM_BLU);
      teamPlaySound("tf2_mission_end_lost",BB_TEAM_RED);
      $RoundRunning = false;
      if(isObject($BB::Minigame))
         $BB::Minigame.schedule(15000,doMinigameReset);
      schedule(15000,0,eval,%cap @ ".capForce = 0;");
      schedule(15000,0,eval,%cap @ ".capTeam = NONE;");
      if(isObject(%cap))
         %cap.schedule(15000,setColor,16);
      if(%lastRound)
      {
         schedule(15000,nextMapRotate);
         return;
      }
      if($RoundLooping && !%lastRound)
         schedule(15000,0,startRound,$RoundGamemode,$RoundTime,YES,$RoundLooping,$RoundLoopAmnt--);
   }
   for(%i=0;%i<ClientGroup.getCount();%i++)
   {
      if(ClientGroup.getObject(%i).bb_team !$= %winTeam)
      {
         ClientGroup.getObject(%i).enterBooMode();
         ClientGroup.getObject(%i).schedule(14999,leaveBooMode);
      }
   }
}

function teamPlaySound(%profile,%team)
{
   for(%i=0;%i<ClientGroup.getCount();%i++)
   {
      %cl = ClientGroup.getObject(%i);
      if(%cl.bb_team $= %team)
         %cl.play2d(%profile);
   }
}