if(!isObject(PlayerNoJet))
   exec("Add-Ons/Player_No_Jet/server.cs");
   
function findTeamSpawnPoint(%team)
{
   if(!isObject(BB_teamSpawnGroup))
      return -1;
   for(%i=0;%i<BB_teamSpawnGroup.getCount();%i++)
   {
      %o = BB_teamSpawnGroup.getObject(%i);
      if(%o.getDatablock().spawnTeam $= %team)
         return vectorAdd(%o.getPosition(),"0 0 0.1");
   }
   return -1;
}

package BB_system_spawnplayer
{
   function GameConnection::spawnPlayer(%this)
   {
      %parent = Parent::spawnPlayer(%this);
      if(%this.bb_nextclass $= %this.bb_class)
         return;
      else if(strLen(%this.bb_nextclass) > 0)
      {
         deleteEngineerBuilding(%this,"sentry");
         deleteEngineerBuilding(%this,"dispenser");
         deleteEngineerBuilding(%this,"teleporterEntrance");
         deleteEngineerBuilding(%this,"teleporterExit");
         %this.bb_class = %this.bb_nextclass;
         %this.bb_classui = %this.bb_nextclassui;
         %this.bb_nextclass = "";
         %this.bb_nextclassui = "";
      }
      if(%this.bb_team !$= BB_TEAM_SPEC)
      {
         %this.player.changeDataBlock(nametoid("PlayerTF2" @ %this.bb_classui));
         giveStockWeapons(%this);
         %this.expectingLoadout[%this.bb_classui] = 1;
         cloudTCP.requestLoadoutData(%this.bl_id,%this.bb_classui);
         if(%this.bb_class $= BB_CLASS_ENGINEER)
            %this.bb_screws = 200;
         %this.player.setTransform(findTeamSpawnPoint(%this.bb_team));
      }
      else if(%this.bb_team $= BB_TEAM_SPEC)
      {
         %this.camera.setMode("Observer");
         %this.camera.setTransform(%this.player.getPosition());
         %this.setControlObject(%this.camera);
         %this.player.setTransform("0 0 -500");
         commandToClient(%this,'centerPrint',"<br><br><br><br>\c6You are spectating.<br>\c6If you want to play, use \c3/jointeam RED/BLU",3.5);
      }
      switch$ (%this.bb_team)
      {
         case BB_TEAM_RED: %color = "1 0 0 1";
         case BB_TEAM_BLU: %color = "0 0 1 1";
         default: %color = "0 1 0 1";
      }
      %this.player.setShapeNameColor(%color);
      if(isObject(%decal = nametoid("BB_DECAL_"@%this.bb_classui)))
         %this.player.setDecalName(fileBase(%decal.textureName));
      return %parent;
   }
   function AIConnection::botSpawnPlayer(%this)
   {
      if(isObject(%this.player))
         %this.player.delete();
      if(!isObject(globalBotGroup))
         new SimSet(globalBotGroup);
      %pos = "0 0 0";
      if(findTeamSpawnPoint(%this.bb_team) !$= -1)
         %pos = findTeamSpawnPoint(%this.bb_team);
      %this.player = new AIPlayer()
      {
         position = %pos;
         datablock = playerNoJet;
         isBastionBot = 1;
         shapename = %this.name;
         bb_team = %team;
         client = %this;
      };
      if(!$DisableControlObject)
         %this.setControlObject(%this.player);
      %this.player.shapename();
      globalBotGroup.add(%this.player);

      if(strLen(%this.bb_nextclass) > 0 && %this.bb_nextclass !$= %this.bb_class)
      {
         deleteEngineerBuilding(%this,"sentry");
         deleteEngineerBuilding(%this,"dispenser");
         deleteEngineerBuilding(%this,"teleporterEntrance");
         deleteEngineerBuilding(%this,"teleporterExit");
         %this.bb_class = %this.bb_nextclass;
         %this.bb_classui = %this.bb_nextclassui;
         %this.bb_nextclass = "";
         %this.bb_nextclassui = "";
      }
      if(%this.bb_team !$= BB_TEAM_SPEC)
      {
         %this.player.changeDataBlock(nametoid("PlayerTF2" @ %this.bb_classui));
         giveStockWeapons(%this);
         if(%this.bb_class $= BB_CLASS_ENGINEER)
            %this.bb_screws = 200;
      }
      switch$ (%this.bb_team)
      {
         case BB_TEAM_RED: %color = "1 0 0 1";
         case BB_TEAM_BLU: %color = "0 0 1 1";
         default: %color = "0 1 0 1";
      }
      %this.player.emptyshape.setShapeNameColor(%color);
      if(isObject(%decal = nametoid("BB_DECAL_"@%this.bb_classui)))
         %this.player.setDecalName(%decal.getName());
         
      %this.player.thinkLoop(%this);
   }
};
activatePackage(BB_system_spawnplayer);