$BB::LoadoutWeapons = "";
function readBackpackFile()
{
   %file = $BB::Path @ "backpack.txt";
   if(!isFile(%file))
   {
      error("Error: Unable to find backpack file ("@%file@")");
      return;
   }
   %fo = new FileObject();
   %fo.openForRead(%file);
   %backpack = "";
   echo("Reading backpack.txt");
   while(!%fo.isEOF())
   {
      %l = %fo.readLine();
      echo(" > READ: "@%l);
      %backpack = %backpack @ %l NL "";
   }
   %fo.close();
   %fo.delete();
   %backpack = trim(%backpack);
   echo("Finished reading, sending data to handleBackpackData(data)");
   handleBackpackData(%backpack);
}
function handleBackpackData(%d)
{
   if($DEBUG)
      echo("handleBackpackData()");
   %currClass = "";
   for(%i=0;%i<getLineCount(%d);%i++)
   {
      %line = getLine(%d,%i);
      if(strLen(trim(%line)) < 1 || getSubStr(ltrim(%line),0,2) $= "//")
         continue;
      if(getSubStr(%line,0,1) $= "!")
      {
         %currClass = "BB_CLASS_"@getSubStr(%line,1,strLen(%line));
         if($DEBUG)
            echo(" - reading class changed to "@%currClass);
         continue;
      }
      %first = firstWord(%line);
      %rest = restWords(%line);
      if(strLen(%currClass) > 0)
      {
         %currSlot = %first;
         %currID = firstWord(%rest) @ "Item";
         %currFlags = restWords(%rest);
         %isStock = false;
         %bgMount = false;
         echo(" - step: "@%currID SPC "("@%currClass SPC %currSlot@") - "@%currFlags);
         for(%x=0;%x<getWordCount(%currFlags);%x++)
         {
            %flagread_curr = getWord(%currFlags,%x);
            switch$ (%flagread_curr)
            {
               case STOCK: %isStock = true;
               case MOUNT: %bgMount = true;
            }
         }
         if(!isObject(%currID))
         {
            echo("   - canceled: weapon doesnt exist");
            continue;
         }
         $BB::LoadoutWeapons = $BB::LoadoutWeapons @ %currClass TAB %currSlot TAB %currID TAB %isStock TAB %bgMount NL "";
      }
   }
}
schedule(100,0,readBackpackFile);