datablock AudioProfile(BackburnerfireSound)
{
   filename    = "./flame_thrower_loop.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BackburnerhitSound)
{
   filename    = "./Hit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(BackburnerfireParticle)
{
	dragCoefficient      = 2.5;
	gravityCoefficient   = -0.17;
	inheritedVelFactor   = 1;
	constantAcceleration = 0;
	lifetimeMS           = 1250;
	lifetimeVarianceMS   = 750;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	= "0.1 0.1 1 1";
	colors[1]	= "1 0.5 0 0.5";
	colors[2]	= "1 0.25 0 0.25";
	colors[3]	= "1 0 0 0";
	sizes[0]	= 0.2;
	sizes[1]	= 0.5;
	sizes[2]	= 0.6;
	sizes[3]	= 0.75;
	times[0]	= 0;
	times[1]	= 0.2;
	times[2]	= 0.8;
	times[3]	= 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BackburnerfireEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 5;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 5;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BackburnerfireParticle";

   uiName = "Backburner Flame";
};

datablock ParticleData(BackburnerambientParticle)
{
	dragCoefficient      = 1.5;
	gravityCoefficient   = -0.25;
	inheritedVelFactor   = 0.5;
	windCoefficient      = 0.1;
	constantAcceleration = 0;
	lifetimeMS           = 900;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.65 0 0.5";
	colors[1]     = "1 0 0 0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.05;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BackburnerambientEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.5;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BackburnerambientParticle";

   uiName = "Backburner Ambient";
};


datablock ParticleData(BackburnerExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.2;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0 0 0 0.6";
	colors[1]     = "0 0 0 0";
	sizes[0]      = 0.35;
	sizes[1]      = 0.9;

	useInvAlpha = true;
};
datablock ParticleEmitterData(BackburnerExplosionEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.5;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BackburnerExplosionParticle";

   uiName = "Backburner Burn";
};

datablock ExplosionData(BackburnerExplosion)
{
	soundProfile = BackburnerhitSound;

   lifeTimeMS = 300;

   emitter[0] = BackburnerexplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 0;
   lightStartColor = "1 0.6 0";
   lightEndColor = "1 0.5 0";

   playerBurnTime = 5000;
};


AddDamageType("Backburner",   '<'@$BB::Path@'weapons/backburner/CI_Backburner> %1',    '%2 <bitmap:'@$BB::Path@'weapons/backburner/CI_Backburner> %1',0.2,1);
datablock ProjectileData(Backburnerprojectile)
{
   backstab		= 60;
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 15;
   directDamageType    = $DamageType::Backburner;
   radiusDamageType    = $DamageType::Backburner;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 2;
   brickExplosionMaxVolumeFloating = 5;

   impactImpulse	     = 100;
   verticalImpulse	  = 0;
   explosion           = BackburnerExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 18;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 600;
   fadeDelay           = 400;
   bounceElasticity    = 0.01;
   bounceFriction      = 0.99;
   isBallistic         = true;
   gravityMod = -0.1;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "1 0.4 0";
};

datablock ItemData(tf2_backburnerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Backburner.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Backburner";
	iconName = "./icon_Backburner";
	doColorShift = falseS;
	colorShiftColor = "1 0.25 0 1";

	 // Dynamic properties defined by the scripts
	image = tf2_backburnerImage;
	canDrop = true;
};

datablock ShapeBaseImageData(tf2_backburnerImage)
{
   shapeFile = "./Backburner.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   //Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = Backburnerprojectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = tf2_backburnerItem.colorShiftColor;

   // Initial start up state
	stateName[0]			= "Initial";
	stateTimeoutValue[0]		= 0.15;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]	= true;
	stateSequence[1]		= "AfterFire";
	stateEmitter[1]			= BackburnerambientEmitter;
	stateEmitterTime[1]		= 1000.0;
	stateEmitterNode[1]		= "muzzlePoint";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= BackburnerfireEmitter;
	stateEmitterTime[2]		= 0.15;
	stateEmitterNode[2]		= "muzzlePoint";
	stateSound[2]			= BackburnerfireSound;
	stateEjectShell[2]       	= false;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateTransitionOnTriggerUp[3]	= "Ready";
	stateSequence[3]		= "Ready";
	stateTransitionOnTriggerDown[3]	= "Fire";

};