datablock itemData(tf2_wranglerItem)
{
	category = "item";
	equipment = true;
	
	uiName = "Wrangler";
	iconName = "base/client/ui/itemIcons/Printr";
	doColorShift = true;
	colorShiftColor = "0.2 0.2 0.2 1";
	
	shapeFile = "./wrangler.dts";
	emap = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	
	image = tf2_wranglerImage;
	canDrop = true;
};

datablock shapeBaseImageData(tf2_wranglerImage)
{
	className = "weaponImage";
	item = tf2_wranglerItem;
	
	shapeFile = tf2_wranglerItem.shapeFile;
	emap = tf2_wranglerItem.emap;
	doColorShift = tf2_wranglerItem.doColorShift;
	colorShiftColor = tfw_wranglerItem.colorShiftColor;
	
	mountPoint = 0;
	offset = "0 -0.05 0";
	//rotation = "0 1 0 180";
	rotation = "0 0 0 180";
	eyeOffset = "0.7 1.2 -0.8";
	//eyeRotation = "0 1 0 180";
	eyeRotation = "0 0 0 180";
	
	correctMuzzleVector = false;
	
	melee = true;
	armReady = true;
	
	stateName[0]                    = "activate";
	stateTimeoutValue[0]            = 0.5;
	stateTransitionOnTimeout[0]     = "ready";
	
	stateName[1]                    = "ready";
	stateTransitionOnTriggerDown[1] = "fire";
	stateAllowImageChange[1]        = true;
	 
	stateName[2]                    = "fire";
	stateTransitionOnTriggerUp[2]   = "ready";
	stateScript[2]                  = "onFire";
};

function tf2_wranglerImage::onUnmount(%this,%obj,%slot)
{
   if(%obj.client.player.hasDisguisedWeapon)
      return;
   for(%i = 0; %i < sentryGroup.getCount(); %i++)
	{
		if(sentryGroup.getObject(%i).sentryOwner == %obj.client)
		{
		   %sntr = sentryGroup.getObject(%i);
		   cancel(%sntr.wrangleSentry);
		   %sntr.stopWrangleTime = $Sim::Time;
		   %sntr.beingWrangled = false;
		   %sntr.wrangler = 0;
		}
	}
}

function tf2_wranglerImage::onMount(%this,%obj,%slot)
{
   if(!isObject(%cl = %obj.client))
      return;
   if(!%obj.client.player.hasDisguisedWeapon)
   {
      for(%i = 0; %i < sentryGroup.getCount(); %i++)
	   {
		   if(sentryGroup.getObject(%i).sentryOwner == %cl)
		   {
		      %sntr = sentryGroup.getObject(%i);
		      %sntr.beingWrangled = true;
		      %sntr.startWrangleTime = $Sim::Time;
		      %sntr.wrangledSentry(%cl);
		      %sntr.wrangler = %cl;
		   }
	   }
   }
}

function SimObject::wrangledSentry(%this,%cl)
{
   cancel(%this.wrangleSentry);
   if(!isObject(%cl.player) || %cl.player.getState() $= Dead)
   {
      %this.beingWrangled = false;
      %this.stopWrangleTime = $Sim::Time;
      return;
   }
   %l=VectorAdd(%cl.player.getEyePoint(), VectorScale(%cl.player.getEyeVector(),100));
   %r=containerRaycast(%cl.player.getEyePoint(), %l, $TypeMasks::All, %cl.player);
   %pos=posFromRaycast(%r);
   %this.wranglePosition = %pos;
   %this.wrangleSentry = %this.schedule(50,wrangledSentry,%cl);
}

function tf2_wranglerImage::onFire(%this,%obj,%slot)
{
   for(%i = 0; %i < sentryGroup.getCount(); %i++)
   {
      if(sentryGroup.getObject(%i).sentryOwner == %cl)
      {
         %sntr = sentryGroup.getObject(%i);
         if($Sim::Time - %sntr.lastWrangleShootTime >= 0.1)
         {
		      %sntr.setImageTrigger(0, 1);
		      %sntr.setImageTrigger(0, 0);
		      %sntr.lastWranglerShootTime = $Sim::Time;
         }
      }
   }
}

//package BB_weapon_tf2wrangler
//{
//   function armor::onTrigger(%this,%obj,%slot,%val)
//   {
//      if(%val && %slot == 4)
//      {
//         if(isObject(%sentry = %obj.client.bb_building["sentry"]))
//            if(%sentry.bb_upgradeLevel >= 3 && %sentry.wrangler $= %obj.client && %sentry.beingWrangled)
//               %obj.client.bb_building["sentry"].sentryRocket();
//      }
//      Parent::onTrigger(%this,%obj,%slot,%val);
//   }
//};
//activatePackage(BB_weapon_tf2wrangler);