if(isFile("Add-Ons/Sound_Blockland/server.cs"))
   forceRequiredAddOn("Sound_Blockland");
else
{
   datablock AudioProfile(Block_MoveBrick_Sound)
   {
      filename = "base/data/sound/clickMove.wav";
      description = AudioClosest3d;
      preload = false;
   };
}

datablock AudioProfile(HuntsmanShootSound)
{
   filename    = "./tf2bowFire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(HuntsmanArrowHitSound)
{
   filename    = "./tf2arrowHit.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(HuntsmanPullbackSound)
{
   filename    = "./tf2bowPull.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(HuntsmanArrowTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 500;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.7 0 0 0.5";
	colors[1]	= "0.7 0 0 0.3";
	colors[2]	= "0.7 0 0 0.0";
	sizes[0]	= 0.1;
	sizes[1]	= 0.05;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.7;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(HuntsmanArrowTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = HuntsmanArrowTrailParticle;

   useEmitterColors = true;
   uiName = "HuntsmanArrow Trail";
};

datablock ParticleData(HuntsmanArrowStickExplosionParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.7 0.0 0.0 0.9";
	colors[1]     = "0.7 0.0 0.0 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.0;
};
datablock ParticleEmitterData(HuntsmanArrowStickExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 80;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HuntsmanArrowStickExplosionParticle";

   useEmitterColors = true;
   uiName = "HuntsmanArrow Stick";
};
datablock ExplosionData(HuntsmanArrowStickExplosion)
{
   //explosionShape = "";
   soundProfile = arrowHitSound;

   lifeTimeMS = 150;

   particleEmitter = HuntsmanArrowStickExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = "";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "0.7 0 0";
   lightEndColor = "0 0 0";
};



datablock ParticleData(HuntsmanArrowExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.3;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.45;
	sizes[1]      = 0.0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(HuntsmanArrowExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HuntsmanArrowExplosionParticle";

   useEmitterColors = true;
   uiName = "HuntsmanArrow Vanish";
};
datablock ExplosionData(HuntsmanArrowExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 50;

   emitter[0] = HuntsmanArrowExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};

AddDamageType("BowHeadshot",   '<bitmap:add-ons/Weapon_Huntsman/CI_bowshot> %1',    '%2 <bitmap:add-ons/Weapon_Huntsman/CI_bowshot> %1',0.75,1);
datablock ProjectileData(TF2BowProjectile)
{
   projectileShapeName = ($TF2Huntsman::AltModels ? "Add-Ons/Weapon_Bow/arrow.dts" : "./arrow.dts");
   directDamage        = 60;
   directDamageType    = $DamageType::ArrowDirect;

   radiusDamage        = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::ArrowDirect;

   explosion             = HuntsmanArrowExplosion;
   stickExplosion        = HuntsmanArrowStickExplosion;
   bloodExplosion        = HuntsmanArrowStickExplosion;
   particleEmitter       = HuntsmanArrowTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   armingDelay         = 4000;
   lifetime            = 4000;
   fadeDelay           = 4000;

   isBallistic         = true;
   bounceAngle         = 170; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;   
   gravityMod = 0.8;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   muzzleVelocity      = 40;
   velInheritFactor    = 1;
   
   uiName = "Huntsman Arrow";
};

datablock ItemData(tf2_huntsmanItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = ($TF2Huntsman::AltModels ? "Add-Ons/Weapon_CompBow/CompBow.dts" : "./Huntsman.dts");
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Huntsman";
	iconName = "./Icon_Huntsman";
	doColorShift = true;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = tf2_huntsmanImage;
	canDrop = true;
};

datablock ShapeBaseImageData(tf2_huntsmanImage)
{
   // Basic Item properties
   shapeFile = ($TF2Huntsman::AltModels ? "Add-Ons/Weapon_CompBow/CompBow.dts" : "./Huntsman.dts");
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = tf2_huntsmanItem;
   ammo = " ";
   projectile = TF2BowProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]			= weaponSwitchSound;
	
	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateScript[2]			= "onPreFire";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 1;
	stateSequence[2]		= ($TF2Huntsman::AltModels ? "Charge" : "Pullback");
	stateSound[2]			= ($TF2Huntsman::AltModels ? "" : HuntsmanPullbackSound);
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.5;
	stateFire[3]			= true;
	stateSequence[3]		= "Fire";
	stateScript[3]			= "onFire";
	stateWaitForTimeout[3]		= true;
	stateAllowImageChange[3]	= false;
	stateSound[3]			= ($TF2Huntsman::AltModels ? CompBowFireSound : HuntsmanShootSound);
	stateAllowImageChange[3]	= false;
	
	stateName[4]			= "Armed";
	stateTransitionOnTimeout[4]	= "Strain";
	stateTimeoutValue[4]		= 4;
	stateWaitForTimeout[4]		= false;
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;
	
	stateName[5]			= "Strain";
	stateScript[5]			= "onStrain";
	stateTransitionOnTimeout[5]	= "Strain";
	stateTimeoutValue[5]		= 0.4;
	stateTransitionOnTriggerUp[5]	= "Fire";
	stateAllowImageChange[5]	= false;
	
	stateName[6]			= "Fire";
	stateTransitionOnTimeout[6]	= "Ready";
	stateTimeoutValue[6]		= 0.2;
	stateFire[6]			= true;
	stateSequence[6]		= "Fire";
	stateScript[6]			= "onFire";
	stateWaitForTimeout[6]		= true;
	stateAllowImageChange[6]	= false;
	stateSound[6]			= ($TF2Huntsman::AltModels ? CompBowFireSound : HuntsmanShootSound);
};

function tf2_huntsmanImage::onPreFire(%this,%obj,%slot)
{
	%obj.bowChargeTime = getSimTime();
}

function tf2_huntsmanImage::onStrain(%this,%obj,%slot)
{
	serverPlay3d(Block_MoveBrick_Sound,%obj.getHackPosition());
	%obj.playThread(2, shiftRight);
}

function tf2_huntsmanImage::onFire(%this,%obj,%slot)
{
	%time = getSimTime() - %obj.bowChargeTime;
	if(%time > 1000)
	{
		TF2BowProjectile.muzzleVelocity = 120;
	}
	else
	{
		TF2BowProjectile.muzzleVelocity = 15 + 80 * %time / 1000;
	}
	
	if(%time > 5000)
	{
		%obj.playThread(2, activate);
		
		%projectile = %this.projectile;
		%spread = 0.01;
		
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
		return;
	}
	else
	{
		Parent::onFire(%this,%obj,%slot);
	}
}

function TF2BowProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %damage = 40*(vectorLen(%obj.initialVelocity)/120);
   %directDamage = mFloatLength(mClampF(%damage, -100, 100),0) * %scale;
   
   %sobj = %obj.sourceObject;
   if(%sobj.getType() & $TypeMasks::PlayerObjectType)
   {
      if(isObject(%sobj.client))
         %sobj.client.play2d(HuntsmanArrowHitSound);
   }
   
   serverPlay3d(huntsmanArrowHitSound,%pos);
   
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %colscale = getWord(%col.getScale(),2);
      if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale)
      {
         %directDamage = %directDamage * 3;
         %damageType = $DamageType::BowHeadshot;
         
         %col.spawnExplosion(critProjectile,%colscale);
         if(isObject(%col.client))
            %col.client.play2d(critRecieveSound);
         
         if(%sobj.getType() & $TypeMasks::PlayerObjectType)
         {
            serverplay3d(critFireSound,%sobj.getHackPosition());
            if(isObject(%sobj.client))
               %sobj.client.play2d(critHitSound);
         }
      }
      
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
}