// kit.cs

datablock itemData(tf2_disguiseItem)
{
	category = "item";
	equipment = true;
	
	uiName = "Disguise Kit";
	iconName = "base/client/ui/plantErrors_small/plantError_teams";
	doColorShift = true;
	colorShiftColor = "1 1 1 1";
	
	shapeFile = "base/data/shapes/brickWeapon.dts";
	emap = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	
	image = tf2_disguiseImage;
	canDrop = true;
};

datablock shapeBaseImageData(tf2_disguiseImage)
{
	className = "weaponImage";
	item = tf2_disguiseItem;
	
	shapeFile = tf2_disguiseItem.shapeFile;
	emap = tf2_disguiseItem.emap;
	doColorShift = tf2_disguiseItem.doColorShift;
	colorShiftColor = tf2_disguiseItem.colorShiftColor;
	
	mountPoint = 0;
	offset = "0 -0.05 0";
	rotation = "0 1 0 180";
	eyeOffset = "0.7 1.2 -0.8";
	eyeRotation = "0 1 0 180";
	
	correctMuzzleVector = false;
	
	melee = true;
	armReady = true;
	
	stateName[0]                    = "activate";
	stateTimeoutValue[0]            = 0.5;
	stateTransitionOnTimeout[0]     = "ready";
	
	stateName[1]                    = "ready";
	stateTransitionOnTriggerDown[1] = "fire";
	stateAllowImageChange[1]        = true;
	 
	stateName[2]                    = "fire";
	stateTransitionOnTriggerUp[2]   = "ready";
	stateScript[2]                  = "onFire";
};

function tf2_disguiseImage::onUnmount(%this,%obj,%slot)
{
   %cl = %obj.client;
   if(%cl.listenForDisguiseClass && !%cl.player.hasDisguisedWeapon)
   {
      commandToClient(%cl,'centerPrint',"",0.001);
      %cl.listenForDisguiseClass = 0;
   }
}

function tf2_disguiseImage::onMount(%this, %player, %slot)
{
	if(isObject(%player.client) == false) // Probably a bot.
		return;
	
	%client = %player.client;
	
	if(!%player.client.player.hasDisguisedWeapon)
	{
	   if(%client.bb_team $= BB_TEAM_BLU)
	   {
	      %otherui = "RED";
	      %othercol = "\c0";
	   }
      else if(%client.bb_team $= BB_TEAM_RED)
      {
         %otherui = "BLU";
         %othercol = "\c1";
      }
	   commandToClient(%client,'centerPrint',"\c6Enter the class in chat that you wish to disguise on "@%othercol@%otherui@" \c6team.");
	   %client.listenForDisguiseClass = 1;
	}
}

function Player::disguise(%this,%team,%class)
{
   if($Sim::Time - %this.lastDisguiseTime <= 1)
      return;
   %this.lastDisguiseTime = $Sim::Time;
   %this.isDisguised = true;
   %this.disguisedAsTeam = %team;
   %this.disguisedAsClass = %class;
   for(%i=0;%i<ClientGroup.getCount();%i++)
   {
      %fcl = ClientGroup.getObject(%i);
      if(%this.lastDisguiseClient $= %fcl)
         continue;
      if(%fcl.bb_team $= %team && %fcl.bb_class $= %class) // PERFECT
         %disguiseCl = %fcl;
   }
   if(!isObject(%disguiseCl))
   {
      
      echo("No disguise cl");
   }
   %this.disguisedAsName = %disguiseCl.name;
   %this.lastDisguiseClient = %disguiseCl;
   %this.setShapeNameDistance(10);
   %this.shapename = %disguiseCl.name;
   %this.shapename();
   switch$ (%team)
   {
      case BB_TEAM_RED: %color = "1 0 0 1";
      case BB_TEAM_BLU: %color = "0 0 1 1";
      default: %color = "0 1 0 1";
   }
   %this.emptyshape.setShapeNameColor(%color);
   %uiclass = strReplace(%class,BB_CLASS_,"");
   %db = nametoid("PlayerTF2"@%uiclass);
   %max = %db.maxTools;
   %i = 0;
   while(!isObject(%image))
   {
      %ir = getRandom(0,%max);
      %image = %this.client.bb_imageSlot[%class,%ir].image;
      if(%i>=9)
      {
         return;
      }
      %i++;
   }
   %this.disguiseWeapon(%image);
}
function Player::undisguise(%this)
{
   if(%this.isDisguised)
   {
      %this.isDisguised = false;
      %this.disguisedAsTeam = %this.bb_team;
      %this.disguisedAsClass = %this.bb_class;
      %this.undisguiseWeapon();
      switch$ (%this.client.bb_team)
      {
         case BB_TEAM_RED: %color = "1 0 0 1";
         case BB_TEAM_BLU: %color = "0 0 1 1";
         default: %color = "0 1 0 1";
      }
      %this.setShapeNameColor(%color);
      %this.setShapeNameDistance();
      cancel(%this.shapeloop);
      %this.emptyshape.delete();
   }
}
function Player::disguiseWeapon(%this,%image)
{
   %this.hasDisguisedWeapon = true;
   %this.disguisedImage = %this.getMountedImage(0);
   %this.mountImage(%image,0,yus);
}
function Player::undisguiseWeapon(%this)
{
   if(%this.hasDisguisedWeapon)
   {
      %this.hasDisguisedWeapon = false;
      %this.unmountImage(0);
      %this.mountImage(%this.disguisedImage,0,yus);
      %this.disguisedImage = 0;
      fixArmReady(%this);
   }
}
package disguiseChat
{
   function ShapeBase::setShapeNameDistance(%this,%d)
   {
      //minimum possible
      if(%this.isDisguised)
         %d = 10;
      Parent::setShapeNameDistance(%this,%d);
   }
   function PlayerData::onRemove(%this,%obj)
   {
      cancel(%obj.shapeloop);
      if(isobject(%obj.emptyshape))
         %obj.emptyshape.delete();
      Parent::onRemove(%this,%obj);
   }
   function Player::mountImage(%this, %image, %slot, %yus)
   {
      if(%this.hasDisguisedWeapon)
         if(%yus $= yus)
            Parent::mountImage(%this,%image,%slot,%yus);
         else
         {
            if(%slot == 0)
               %this.disguisedImage = %image;
            fixArmReady(%this);
            return;
         }
      else
         Parent::mountImage(%this,%image,%slot,%yus);
   }
   function Player::unmountImage(%this, %slot, %yus)
   {
      if(%this.hasDisguisedWeapon)
         if(%yus $= yus)
            Parent::unmountImage(%this,%slot);
         else
         {
            if(%slot == 0)
               %this.disguisedImage = 0;
            fixArmReady(%this);
            return;
         }
      else
         Parent::unmountImage(%this,%slot);
   }
	function gameConnection::onDeath(%this, %sourceObject, %sourceClient, %damageType, %damageLoc)
	{
		if(isObject(%sourceObject) == true && %this.player.isDisguised)
			%this.player.undisguise();
      %this.player.undisguiseWeapon();
		
		parent::onDeath(%this, %sourceObject, %sourceClient, %damageType, %damageLoc);
	}
	
	function projectile::onAdd(%this, %wtf)
	{
		if(isObject((%client = %this.client)) == true && isObject((%player = %client.player)) && %this.sourceObject == %player &&	%player.isDisguised)
		{
			%datablock = %this.getDatablock();
			%damage = %datablock.directDamage;
			
			if(isObject((%explosion = %datablock.explosion)) == true)
				%damage += %explosion.radiusDamage;
			
			if(%damage > 0)
			{
				%player.undisguise();
			}
		}
		
		parent::onAdd(%this, %wtf);
	}
	
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
	   if(%val && %triggerNum == 0 && %obj.hasDisguisedWeapon)
	      %obj.undisguiseWeapon();
		if(%obj.isDisguised && %triggerNum == 0)
		{
         //return parent::onTrigger(%this, %obj, %triggerNum, %val);
			
			%client = %obj.client;
			%player = %obj;
			
			%weapon = %obj.getMountedImage(0);
			
			if(isObject(%weapon) == true && %weapon.melee == true
				&& isObject(%weapon.projectile) == true)
			{
				%damage = %weapon.projectile.directDamage;
				
				if(%damage > 0)
				{
					%player.undisguise();
				}
			}
		}
		
		parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(disguiseChat);