AddDamageType("tf2_wrench",   '<bitmap:'@$BB::Path@'weapons/melee/ci_wrench> %1',    '%2 <bitmap:'@$BB::Path@'weapons/melee/ci_wrench> %1',0.75,1);

//////////
// item //
//////////
datablock ItemData(tf2_wrenchItem : wrenchItem)
{
	uiName = "TF2 Wrench";
	colorShiftColor = vectorScale(wrenchItem.colorShiftColor,0.5) SPC 1;
	image = tf2_wrenchImage;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(tf2_wrenchImage : wrenchImage)
{
   item = tf2_wrenchItem;
   ammo = " ";
   projectile = wrenchProjectile;
   projectileType = Projectile;
   
   showBricks = 0;
   
   doColorShift = true;
   colorShiftColor = tf2_wrenchItem.colorShiftColor;
   
   raycastWeaponRange = 3;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastExplosionProjectile = wrenchProjectile;
   raycastDirectDamage = 35;
   raycastDirectDamageType = $DamageType::tf2_wrench;
   
   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.3;
	stateSequence[0]                 = "Activate";
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateSequence[1]                 = "Ready";
	stateTransitionOnTriggerDown[1]  = "FireA";
	stateAllowImageChange[1]         = true;
	
	stateName[2]			= "FireA";
	stateSequence[2]		= "Fire";
	stateTransitionOnTimeout[2]	= "FireB";
	stateTimeoutValue[2]		= 0.5;
	stateScript[2]			= "onFire";
	stateAllowImageChange[2]	= false;
	stateWaitForTimeout[2]		= true;
	
	stateName[3]			= "FireB";
	stateSequence[3]                 = "Ready";
	stateTransitionOnTimeout[3]	= "CheckFire";
	stateScript[3]			= "";
	stateTimeoutValue[3]		= 0.3;
	stateAllowImageChange[3]	= true;
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "FireA";
	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function tf2_wrenchImage::onFire(%this, %obj, %slot)
{
	Parent::onFire(%this, %obj, %slot);
	%obj.playThread(2,wrench);
}

function tf2_wrenchImage::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
   if(isObject(%col.dataBlock) && (%col.dataBlock.getName() $= "playerSentryTop" || %col.dataBlock.getName() $= "playerSentryBottom"))
   {
	   if(%col.dataBlock.getName() $= "playerSentryTop")
		   %sentry = %col;
	   if(%col.dataBlock.getName() $= "playerSentryBottom")
		   %sentry = %col.sentryTop;
      if(%sentry.beingSapped)
      {
         if(%sentry.sapperHealth <= 1)
         {
            messageAll('',%obj.client.name SPC "<bitmap:"@$BB::Path@"weapons/melee/ci_wrench>" SPC "Sapper ("@%sentry.spySapping.name@")");
            %sentry.stopSap();
         }
         %sentry.sapperHealth--;
      }
	   if(!isObject(%sentry))
	   {
		   parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		   return;
	   }
	   if(%obj.client.bb_screws >= 25)
	   {
	      %sentry.sentryXP += 25;
	      %obj.client.bb_screws=%obj.client.bb_screws-25;
	   }
	   else if(%obj.client.bb_screws > 0)
	   {
	      %sentry.sentryXP += %obj.client.bb_screws;
	      %obj.client.bb_screws = 0;
	   }
	   else if(%obj.client.bb_screws <= 0)
	   {
	      %obj.client.bb_screws = 0;
	      return;
	   }
	   %kit = %sentry.sentryKit;
	   %level = %sentry.sentryLevel;
   
   if(%sentry.getDamageLevel() > 0 && %obj.client.bb_screws > 0)
   {
      %maxres = 10;
      if(%obj.client.bb_screws >= %maxres)
         %res = 10;
      else if(%obj.client.bb_screws >= 0)
         %res = %obj.client.bb_screws;
      else
         %res = 0;
      if(%res > 0)
      {
         %sentry.setDamageLevel(%sentry.getDamageLevel()-%res*3);
         %obj.client.bb_screws -= %res;
      }
   }

	if(%sentry.sentryXP >= $sentryUpgradeThreshold_[%kit @ "_" @ %level + 1] && $sentryImage_[%kit @ "_" @ %level + 1] !$= "")
	{
		//UPRADIN' A SENTRY
		%sentry.sentryLevel++;
		%sentry.sentryXP = 0; //reset XP
		%level++;
		%sentry.setVelocity("0 0" SPC getWord(%obj.getVelocity(),4));
		%sentry.mountImage($sentryImage_[%kit @ "_" @ %level], 0);
		serverPlay3D(sentryUpgradeSound, %sentry.getPosition());
%pos = %sentry.getPosition();

%p = new Projectile()
  {
     dataBlock = toolboxExplosion2Projectile;
     initialPosition = %pos;
     initialVelocity = "0 0 1";
     client = %obj.client;
     sourceClient = %obj.client;
  };
MissionCleanup.add(%p);
%p.explode();
	}

   }
   else if(%col.class $= "EngineerBuilding")
   {
      if(%col.beingSapped)
      {
         if(%col.sapperHealth <= 1)
         {
            messageAll('',%obj.client.name SPC "<bitmap:"@$BB::Path@"weapons/melee/ci_wrench>" SPC "Sapper ("@%col.spySapping.name@")");
            %col.stopSap();
         }
         %col.sapperHealth--;
      }
      %output = 0;
      %output = %obj.client.upgradeBuilding(25,%col);
   }
   else
   {
   %colType = %col.getType(); //%col changes to CorpseObjectType if you kill a player 
   
   if(!isObject(CritProjectile))
      %crit = 0;
   
   if(%this.raycastDirectDamage > 0 && %colType & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
   {
      if(isObject(%col.spawnBrick) && %col.spawnBrick.getGroup().client == %obj.client)
         %dmg = 1;
      if(miniGameCanDamage(%obj,%col) == 1 || %dmg)
         %this.onRaycastDamage(%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
   }
   
   if(isObject(%this.raycastExplosionProjectile))
   {
      %scaleFactor = getWord(%obj.getScale(), 2);
      %p = new Projectile()
      {
         dataBlock = %this.raycastExplosionProjectile;
         initialPosition = %pos;
         initialVelocity = %normal;
         sourceObject = %obj;
         client = %obj.client;
         sourceSlot = 0;
         originPoint = %pos;
      };
      MissionCleanup.add(%p);
      %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
      %p.explode();
   }
   }
   if(%output)
      serverplay3d(wrenchHitSound,%pos);
   else
      serverplay3d(wrenchMissSound,%pos);
}

function tf2_wrenchImage::isRaycastCritical(%this,%obj,%slot,%col,%pos,%normal,%hit)
{
   if(isObject(%col) && %col.getType() & $TypeMasks::PlayerObjectType)
   {
      for(%i=0;%i<%col.dataBlock.maxTools;%i++)
      {
         if(%col.tool[%i].image.isCloakWatch)
            return 1;
      }
   }
   return tf2MeleeWeaponImage::isRaycastCritical(%this,%obj,%slot,%col,%pos,%normal,%hit);
}