datablock ItemData(tf2_flagItem : printGun)
{
   image = "";
   uiName = "";
   
   doColorShift = true;
   colorShiftColor = "255 255 255 255";
   
   shapeFile = $BB::Path @ "data/TF2briefcase.dts";
};

datablock ItemData(tf2_redFlagItem : tf2_flagItem)
{
   colorShiftColor = "165 68 23 255";
};
datablock ItemData(tf2_bluFlagItem : tf2_flagItem)
{
   colorShiftColor = "53 147 175 255";
};

function serverCmdLoadFlags(%cl)
{
   if(!%cl.isAdmin)
      return;
   %reds = nametoid("_redFlagSpawn");
   %blus = nametoid("_bluFlagSpawn");
   if(isObject(%reds))
      %reds.becomeFlag();
   if(isObject(%blus))
      %blus.becomeFlag();
}

function fxDTSBrick::becomeFlag(%this)
{
   if(isObject(%this.flagAttach))
      %this.flagAttach.delete();
   %team = strReplace(strReplace(%this.getName(),"_",""),"FlagSpawn","");
   createFlagObject(%team,vectorAdd(%this.getPosition(),"0 0 1"));
   %this.flagAttach = nametoid(%team@"Flag");
   nametoid(%team@"Flag").spawnBrick = %this;
   nametoid(%team@"Flag").schedule(5,beginRotating);
}

function Item::beginRotating(%this)
{
   %this.rotate = 1;
}

function createFlagObject(%team,%pos)
{
   %flagName = %team @ "Flag";
   %evalStr = "new Item("@%flagName@") { datablock = tf2_"@strLwr(%team)@"FlagItem; };";
   eval(%evalstr);
   eval(%flagName@".flagTeam = \"BB_TEAM_"@%team@"\";");
   eval(%flagName@".startingPosition = \""@%pos@"\";");
   eval(%flagName@".setTransform(\""@%pos@"\");");
}

function tf2_redFlagItem::onPickup(%this,%obj,%pl)
{
   if(%pl.carryingFlag && %pl.flagCarried !$= %obj)
   {
      if(%pl.flagCarried.flagTeam $= %pl.client.bb_team)
         return;
      %flag = %pl.flagCarried;
      %flag.setShapeName("");
      %flag.droppedHere = false;
      %flag.pickedUp = false;
      %flag.carrier = 0;
      tf2_redFlagItem.returnToBase(%pl.flagCarried,true);
      %pl.carryingFlag = 0;
      %pl.flagCarried = 0;
      %pl.hideNode("pack");
      messageAll('',"\c3Alert! \c6The "@(%flag.flagTeam $= BB_TEAM_RED ? "\c0RED" : "\c1BLU")@" \c6intellegence has been captured.");
      if(%flag.flagTeam $= BB_TEAM_RED)
      {
         teamPlaySound("tf2_intel_enemy_captured",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_RED,"red","cap","Our INTELLEGENCE has been captured");
         teamPlaySound("tf2_intel_local_captured",BB_TEAM_BLU);
         giveTeamNotice(BB_TEAM_BLU,"red","cap","The ENEMY INTELLEGENCE has been captured");
      }
      if(%flag.flagTeam $= BB_TEAM_BLU)
      {
         teamPlaySound("tf2_intel_enemy_captured",BB_TEAM_BLU);
         giveTeamNotice(BB_TEAM_RED,"blu","cap","The ENEMY INTELLEGENCE was captured");
         teamPlaySound("tf2_intel_local_captured",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_BLU,"blu","cap","Our INTELLEGENCE was captured");
      }
      %pl.client.score++;
   }
   if(%obj.flagTeam $= %pl.client.bb_team)
      return;
   if(%obj.pickedUp)
      return;
   if(%obj.droppedHere)
   {
      cancel(%obj.droploop);
      %obj.droppedHere = false;
      %obj.pickedUp = true;
      %obj.carrier = %pl;
      %obj.setTransform(%obj.originalTrans);
      %obj.fadeOut();
      %pl.carryingFlag = true;
      %pl.flagCarried = %obj;
      %pl.setNodeColor("pack",(%obj.flagTeam $= BB_TEAM_RED ? "1 0 0" : "0 0 1") SPC "1");
      %pl.unhidenode("pack");
      %obj.setShapeName("");
      messageAll('',"\c3Alert! \c6The "@(%obj.flagTeam $= BB_TEAM_RED ? "\c0RED" : "\c1BLU")@" \c6intellegence has been picked up.");
      if(%obj.flagTeam $= BB_TEAM_RED)
      {
         teamPlaySound("tf2_intel_enemy_stolen",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_RED,"red","pick","Our INTELLEGENCE was picked up");
         teamPlaySound("tf2_intel_local_stolen",BB_TEAM_BLU);
         giveTeamNotice(BB_TAEM_BLU,"red","pick","The ENEMY INTELLEGENCE was picked up");
      }
      if(%obj.flagTeam $= BB_TEAM_BLU)
      {
         teamPlaySound("tf2_intel_enemy_stolen",BB_TEAM_BLU);
         giveTeamNotice(BB_TEAM_BLU,"red","pick","The ENEMY INTELLEGENCE was picked up");
         teamPlaySound("tf2_intel_local_stolen",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_RED,"red","pick","Our INTELLEGENCE was picked up");
      }
      return;
   }
   %obj.pickedUp = true;
   %obj.carrier = %pl;
   %obj.fadeOut();
   %pl.carryingFlag = true;
   %pl.setNodeColor("pack",(%obj.flagTeam $= BB_TEAM_RED ? "1 0 0" : "0 0 1") SPC "1");
   %pl.unhidenode("pack");
   %pl.flagCarried = %obj;
   messageAll('',"\c3Alert! \c6The "@(%obj.flagTeam $= BB_TEAM_RED ? "\c0RED" : "\c1BLU")@" \c6intellegence has been picked up.");
   if(%obj.flagTeam $= BB_TEAM_RED)
   {
      teamPlaySound("tf2_intel_enemy_stolen",BB_TEAM_RED);
      giveTeamNotice(BB_TEAM_RED,"red","pick","Our INTELLEGENCE was picked up");
      teamPlaySound("tf2_intel_local_stolen",BB_TEAM_BLU);
      giveTeamNotice(BB_TEAM_BLU,"red","pick","The ENEMY INTELLEGENCE was picked up");
   }
   if(%obj.flagTeam $= BB_TEAM_BLU)
   {
      teamPlaySound("tf2_intel_enemy_stolen",BB_TEAM_BLU);
      giveTeamNotice(BB_TEAM_BLU,"blu","pick","Our INTELLEGENCE was picked up");
      teamPlaySound("tf2_intel_local_stolen",BB_TEAM_RED);
      giveTeamNotice(BB_TEAM_RED,"blu","pick","The ENEMY INTELLEGENCE was picked up");
   }
}

function tf2_redFlagItem::dropHere(%this,%obj,%pos)
{
   if(!%obj.pickedUp)
      return;
   %obj.pickedUp = false;
   %obj.droppedHere = true;
   %obj.carrier = 0;
   %obj.fadeIn();
   %obj.setTransform(vectorAdd(%pos,"0 0 3"));
   %obj.dropTime = 30;
   %obj.getDatablock().dropCountDownLoop(%obj);
   messageAll('',"\c3Alert! \c6The "@(%obj.flagTeam $= BB_TEAM_RED ? "\c0RED" : "\c1BLU")@" \c6intellegence has been dropped.");
   if(%obj.flagTeam $= BB_TEAM_RED)
   {
      teamPlaySound("tf2_intel_enemy_dropped",BB_TEAM_RED);
      giveTeamNotice(BB_TEAM_RED,"red","drop","Our INTELLEGENCE was dropped");
      teamPlaySound("tf2_intel_local_dropped",BB_TEAM_BLU);
      giveTeamNotice(BB_TEAM_BLU,"red","drop","The ENEMY INTELLEGENCE was dropped");
   }
   if(%obj.flagTeam $= BB_TEAM_BLU)
   {
      teamPlaySound("tf2_intel_enemy_dropped",BB_TEAM_BLU);
      giveTeamNotice(BB_TEAM_BLU,"blu","drop","Our INTELLEGENCE was dropped");
      teamPlaySound("tf2_intel_local_dropped",BB_TEAM_RED);
      giveTeamNotice(BB_TEAM_RED,"blu","drop","The ENEMY INTELLEGENCE was dropped");
   }
}

function tf2_redFlagItem::returnToBase(%this,%obj,%n)
{
   %obj.setShapeName("");
   %obj.fadeIn();
   %obj.setTransform(%obj.startingPosition);
   %obj.pickedUp = false;
   %obj.droppedHere = false;
   %obj.carrier = 0;
   if(!%n)
   {
      messageAll('',"\c3Alert! \c6The "@(%obj.flagTeam $= BB_TEAM_RED ? "\c0RED" : "\c1BLU")@" \c6intellegence has been returned to the base.");
      if(%obj.flagTeam $= BB_TEAM_RED)
      {
         teamPlaySound("tf2_intel_local_returned",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_RED,"red","ret","Our INTELLEGENCE was returned to our base");
      }
      if(%obj.flagTeam $= BB_TEAM_BLU)
      {
         teamPlaySound("tf2_intel_local_returned",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_BLU,"blu","ret","Our INTELLEGENCE was returned to our base");
      }
   }
}

function tf2_redFlagItem::dropCountDownLoop(%this,%obj)
{
   cancel(%obj.dropLoop);
   if(%obj.dropTime < 1)
   {
      %obj.getDatablock().returnToBase(%obj);
      return;
   }
   %obj.setShapeName(%obj.dropTime);
   %obj.dropTime--;
   %obj.dropLoop = %this.schedule(1000,dropCountDownLoop,%obj);
}

function tf2_bluFlagItem::onPickup(%this,%obj,%pl)
{
   if(%pl.carryingFlag && %pl.flagCarried !$= %obj)
   {
      if(%pl.flagCarried.flagTeam $= %pl.client.bb_team)
         return;
      %flag = %pl.flagCarried;
      %flag.setShapeName("");
      %flag.droppedHere = false;
      %flag.pickedUp = false;
      %flag.carrier = 0;
      tf2_bluFlagItem.returnToBase(%pl.flagCarried,true);
      %pl.carryingFlag = 0;
      %pl.flagCarried = 0;
      %pl.hideNode("pack");
      messageAll('',"\c3Alert! \c6The "@(%flag.flagTeam $= BB_TEAM_RED ? "\c0RED" : "\c1BLU")@" \c6intellegence has been captured.");
      if(%flag.flagTeam $= BB_TEAM_RED)
      {
         teamPlaySound("tf2_intel_enemy_captured",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_RED,"red","cap","Our INTELLEGENCE has been captured");
         teamPlaySound("tf2_intel_local_captured",BB_TEAM_BLU);
         giveTeamNotice(BB_TEAM_BLU,"red","cap","The ENEMY INTELLEGENCE has been captured");
      }
      if(%flag.flagTeam $= BB_TEAM_BLU)
      {
         teamPlaySound("tf2_intel_enemy_captured",BB_TEAM_BLU);
         giveTeamNotice(BB_TEAM_RED,"blu","cap","The ENEMY INTELLEGENCE was captured");
         teamPlaySound("tf2_intel_local_captured",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_BLU,"blu","cap","Our INTELLEGENCE was captured");
      }
      %pl.client.score++;
   }
   if(%obj.flagTeam $= %pl.client.bb_team)
      return;
   if(%obj.pickedUp)
      return;
   if(%obj.droppedHere)
   {
      cancel(%obj.droploop);
      %obj.droppedHere = false;
      %obj.pickedUp = true;
      %obj.carrier = %pl;
      %obj.setTransform(%obj.originalTrans);
      %obj.fadeOut();
      %pl.carryingFlag = true;
      %pl.flagCarried = %obj;
      %pl.setNodeColor("pack",(%obj.flagTeam $= BB_TEAM_RED ? "1 0 0" : "0 0 1") SPC "1");
      %pl.unhidenode("pack");
      %obj.setShapeName("");
      messageAll('',"\c3Alert! \c6The "@(%obj.flagTeam $= BB_TEAM_RED ? "\c0RED" : "\c1BLU")@" \c6intellegence has been picked up.");
      if(%obj.flagTeam $= BB_TEAM_RED)
      {
         teamPlaySound("tf2_intel_enemy_stolen",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_RED,"red","pick","Our INTELLEGENCE was picked up");
         teamPlaySound("tf2_intel_local_stolen",BB_TEAM_BLU);
         giveTeamNotice(BB_TAEM_BLU,"red","pick","The ENEMY INTELLEGENCE was picked up");
      }
      if(%obj.flagTeam $= BB_TEAM_BLU)
      {
         teamPlaySound("tf2_intel_enemy_stolen",BB_TEAM_BLU);
         giveTeamNotice(BB_TEAM_BLU,"red","pick","The ENEMY INTELLEGENCE was picked up");
         teamPlaySound("tf2_intel_local_stolen",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_RED,"red","pick","Our INTELLEGENCE was picked up");
      }
      return;
   }
   %obj.pickedUp = true;
   %obj.carrier = %pl;
   %obj.fadeOut();
   %pl.carryingFlag = true;
   %pl.setNodeColor("pack",(%obj.flagTeam $= BB_TEAM_RED ? "1 0 0" : "0 0 1") SPC "1");
   %pl.unhidenode("pack");
   %pl.flagCarried = %obj;
   messageAll('',"\c3Alert! \c6The "@(%obj.flagTeam $= BB_TEAM_RED ? "\c0RED" : "\c1BLU")@" \c6intellegence has been picked up.");
   if(%obj.flagTeam $= BB_TEAM_RED)
   {
      teamPlaySound("tf2_intel_enemy_stolen",BB_TEAM_RED);
      giveTeamNotice(BB_TEAM_RED,"red","pick","Our INTELLEGENCE was picked up");
      teamPlaySound("tf2_intel_local_stolen",BB_TEAM_BLU);
      giveTeamNotice(BB_TEAM_BLU,"red","pick","The ENEMY INTELLEGENCE was picked up");
   }
   if(%obj.flagTeam $= BB_TEAM_BLU)
   {
      teamPlaySound("tf2_intel_enemy_stolen",BB_TEAM_BLU);
      giveTeamNotice(BB_TEAM_BLU,"blu","pick","Our INTELLEGENCE was picked up");
      teamPlaySound("tf2_intel_local_stolen",BB_TEAM_RED);
      giveTeamNotice(BB_TEAM_RED,"blu","pick","The ENEMY INTELLEGENCE was picked up");
   }
}

function tf2_bluFlagItem::dropHere(%this,%obj,%pos)
{
   if(!%obj.pickedUp)
      return;
   %obj.pickedUp = false;
   %obj.droppedHere = true;
   %obj.carrier = 0;
   %obj.fadeIn();
   %obj.setTransform(vectorAdd(%pos,"0 0 3"));
   %obj.dropTime = 30;
   %obj.getDatablock().dropCountDownLoop(%obj);
   messageAll('',"\c3Alert! \c6The "@(%obj.flagTeam $= BB_TEAM_RED ? "\c0RED" : "\c1BLU")@" \c6intellegence has been dropped.");
   if(%obj.flagTeam $= BB_TEAM_RED)
   {
      teamPlaySound("tf2_intel_enemy_dropped",BB_TEAM_RED);
      giveTeamNotice(BB_TEAM_RED,"red","drop","Our INTELLEGENCE was dropped");
      teamPlaySound("tf2_intel_local_dropped",BB_TEAM_BLU);
      giveTeamNotice(BB_TEAM_BLU,"red","drop","The ENEMY INTELLEGENCE was dropped");
   }
   if(%obj.flagTeam $= BB_TEAM_BLU)
   {
      teamPlaySound("tf2_intel_enemy_dropped",BB_TEAM_BLU);
      giveTeamNotice(BB_TEAM_BLU,"blu","drop","Our INTELLEGENCE was dropped");
      teamPlaySound("tf2_intel_local_dropped",BB_TEAM_RED);
      giveTeamNotice(BB_TEAM_RED,"blu","drop","The ENEMY INTELLEGENCE was dropped");
   }
}

function tf2_bluFlagItem::returnToBase(%this,%obj,%n)
{
   %obj.setShapeName("");
   %obj.fadeIn();
   %obj.setTransform(%obj.startingPosition);
   %obj.pickedUp = false;
   %obj.droppedHere = false;
   %obj.carrier = 0;
   if(!%n)
   {
      messageAll('',"\c3Alert! \c6The "@(%obj.flagTeam $= BB_TEAM_RED ? "\c0RED" : "\c1BLU")@" \c6intellegence has been returned to the base.");
      if(%obj.flagTeam $= BB_TEAM_RED)
      {
         teamPlaySound("tf2_intel_local_returned",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_RED,"red","ret","Our INTELLEGENCE was returned to our base");
      }
      if(%obj.flagTeam $= BB_TEAM_BLU)
      {
         teamPlaySound("tf2_intel_local_returned",BB_TEAM_RED);
         giveTeamNotice(BB_TEAM_BLU,"blu","ret","Our INTELLEGENCE was returned to our base");
      }
   }
}

function tf2_bluFlagItem::dropCountDownLoop(%this,%obj)
{
   cancel(%obj.dropLoop);
   if(%obj.dropTime < 1)
   {
      %obj.getDatablock().returnToBase(%obj);
      return;
   }
   %obj.setShapeName(%obj.dropTime);
   %obj.dropTime--;
   %obj.dropLoop = %this.schedule(1000,dropCountDownLoop,%obj);
}

package BB_gamemode_captureFlag
{
   function armor::onDisabled(%this,%obj)
   {
      if(%obj.carryingFlag)
      {
         %pos = %obj.getTransform();
         %obj.flagCarried.getDatablock().schedule(200,dropHere,%obj.flagCarried,%pos);
         //%obj.hideNode("pack");
      }
      Parent::onDisabled(%this,%obj);
   }
};
activatePackage(BB_gamemode_captureFlag);